-- for CCLuaEngine traceback
function __G__TRACKBACK__(msg)
    print("----------------------------------------")
    print("LUA ERROR: " .. tostring(msg) .. "\n")
    print(debug.traceback())
    print("----------------------------------------")
end

-- avoid memory leak
collectgarbage("setpause", 100)
collectgarbage("setstepmul", 5000)

-- localization

function LOCALIZE(string_id)
	local ret = localization and localization[string_id]
	return ret or string_id
end

--

game = {}
gameState = {}
gameState.hog1 = {}

function core.resetscene()
--    core.CCLOG("insideReset")
  scene_selectors = {};
--    core.CCLOG("insideReset1")
  scene_members = {};
--    core.CCLOG("insideReset2")
  scene_animations = {};
--    core.CCLOG("insideReset3")
  game.resetscene();
end

function game.resetscene()
--    core.CCLOG("game.resetscene")
  game.onSceneStart = nil;
--    core.CCLOG("game.resetscene2")
  game.onAnimationEnd = nil;
--    core.CCLOG("game.resetscene3")
end

local old_ex = core.executeScript;
function core.executeScript(script)
  old_ex("game/"..script..".lua");
end

local old_crNodes = core.createNodes;
function core.createNodes(script)
  return old_crNodes("ccb/"..script..".ccbi");
end

function game.getTransition(name, scene)
  return CCTransitionCrossFade:create(0.5, scene);
end

function onSceneEvent()
	print("onSceneEvent")
end

-- registered functions in core
-- createScene
-- createNodes
-- replaceWithScene
function startScene(name, script, cleanup)
--    core.CCLOG("HousePressed5 ")
    local file = "ccb/"..name..".ccbi";
    core.CCLOG("FILE: "..tostring(file))
    local core = core;
    scriptFileName = script
--    core.CCLOG("SCRIPT: "..tostring(scriptFileName))
    core.resetscene();
    
    currentScene, currentSceneTopElement, forbidden = core.createScene(file);
--    core.CCLOG("HousePressed5 ")
--    core.CCLOG("HousePressed6 script ".. tostring(script))
--    core.CCLOG("HousePressed6 forbidden ".. tostring(forbidden))
    print(script)
    if(script) then
        if(forbidden) then
            --print("exit")
            --return
--            core.CCLOG("HousePressed7 forbidden")
            gameState.currentScene = {"scene_2", "02_crossroad", true}
            core.executeScript("02_crossroad");
        else
--            core.CCLOG("HousePressed7 unforbidden")
            core.executeScript(script);
        end
        
    end
    local scene = game.getTransition(name, currentScene);
    if (cleanup) then
        CCTextureCache:sharedTextureCache():removeUnusedTextures();
    end
    core.replaceWithScene(scene);
    core.saveState()
    if(game.onSceneStart) then
        game.onSceneStart();
    end

end

local function dump(t,parent, seen)
	seen[t]=true
	local s={}
	local n=0
	for k, v in pairs(t) do
    local ty = type(v)
    if ty=="table" or ty=="number" or ty=="string" or ty=="boolean" then
      n=n+1
      s[n]=k
    else
      print("Warning: attemp to save "..ty)
    end
	end
	table.sort(s)
	for k,v in ipairs(s) do
		local key
		if tonumber(v) then
			key = parent.."["..v.."]"
		else
			key = parent.."."..v
		end
		v=t[v]
		private.save(key, v)
		if type(v)=="table" and not seen[v] then
			dump(v,key, seen)
		end
	end
end


function core.saveState()
  print("Saving started...")
  private.startSave()
  local seen={}
  dump(gameState,"", seen)
  print("Saving ended...")
  private.endSave()
end

function core.resetSave()
  core.executeScript("defaultState")
  core.saveState()
  print("Done. Save cleared.");
end

core.minigames = {}
core.minigames.puzzle = {}


function core.createSkipButton(onSkipPressed,inActiveGame)
    
    --createButton
    skipPuzzleButton = CCControl.create(0,"res/gui/pr_mini_base.png","skipPuzzleGameSelector")
    skipPuzzleButton:setPosition(ccp((scene_members.activeArea:getContentSize().width)/2,--[[scene_members.activeArea:getPositionY() + ]](scene_members.activeArea:getContentSize().height-5)))
    skipPuzzleButton:setScale(0.4)
    print("tryadding")
    skipPuzzleButton:setAnchorPoint(ccp(0.5,0))
    scene_members.activeArea:addChild(skipPuzzleButton)
    print("added")

    local descr = CCLabelBMFont:create(LOCALIZE("CONTROL_CONTINUE"),"res/philosopher_32.fnt",400,2)
    
    
    local buttonProgressBar = CCProgressTimer:create(CCSprite:create("res/gui/pr_mini_progress.png"))
    skipPuzzleButton:addChild(buttonProgressBar,10)
    skipPuzzleButton:addChild(descr,12)
    buttonProgressBar:setScaleX(1.7)
    buttonProgressBar:setScaleY(2.)
    skipPuzzleButton:setTouchEnabled(false)
    buttonProgressBar:setColor(ccc3(210,210,210))
    descr:setPosition(ccp(   skipPuzzleButton:getContentSize().width/2,skipPuzzleButton:getContentSize().height/2 + 5))
    buttonProgressBar:setPosition(ccp(   skipPuzzleButton:getContentSize().width/2,skipPuzzleButton:getContentSize().height/2 - 5 ))
    local x,y = buttonProgressBar:getPosition()
    buttonProgressBar:setType(kCCProgressTimerTypeBar)
    buttonProgressBar:setMidpoint( ccp(0,y))
    buttonProgressBar:setBarChangeRate(ccp(1,0))
    puzzleHintPercent = 15
    buttonProgressBar:setPercentage(puzzleHintPercent)
    
    function tick(dt)
        --print("tick:",dt)
        if(inActiveGame)then
            return
        end
        if(puzzleHintPercent >= 100) then
            return
        end
        
        if(puzzleHintPercent < 100) then
            puzzleHintPercent = puzzleHintPercent + 0.5
            if(puzzleHintPercent > 87) then
                puzzleHintPercent = 100
            end
            if(puzzleHintPercent >= 100)then
                buttonProgressBar:setColor(ccc3(255,255,255))
                skipPuzzleButton:setTouchEnabled(true)
            end
            buttonProgressBar:setPercentage(puzzleHintPercent)
        end
        
        
    end
    
    if(inActiveGame)then
        skipPuzzleButton:setVisible(false)
    end
    
    function core.resetProgressButton()
        --
    end
    
    function scene_selectors.skipPuzzleGameSelector(sender)
        if(onSkipPressed)then
            onSkipPressed()
        end
        --eixt
    end

end

function core.minigames.puzzle.loadMiniGame(sceneName, layerName, succeedMiniGame, coords, initAfterLoad, onItemPlaced, onCancelMinigame,inActiveGame,notNeedToreorder)

	-- создаём массив для того, чтобы знать правильные 
	itemOnPlace = {}

	local function saveMinigame()
		parent = scene_members[layerName]
		gameState.minigames[sceneName].coords = {}
		for i = 1,#coords do
            if(layerName == "frameMinigame")then
                if(scene_members.activeArea == nil)then
                    return
                end
                item = scene_members.activeArea:getChildByTag(i+5000)
            else
            if(scene_members.activeArea == nil)then
                return
            end
			item = scene_members.activeArea:getChildByTag(i)
            end
			--item = scene_members["item"..i]
			xpos, ypos = item:getPosition()
			gameState.minigames[sceneName].coords[i] = {xpos, ypos}
		end
        
	end
    
  

	game.initSubScene(sceneName, layerName,saveMinigame, function()
						if onCancelMinigame  then onCancelMinigame() end
                      local items = 0
                      for cur = 1,#coords do
                          if (itemOnPlace[cur]) then
                          items = items + itemOnPlace[cur]
                          end
                      end
                      if (items == #coords) then succeedMiniGame() end
					  end,nil,scene_members.puzzleGameNode)
   
	scene_members.puzzleGameNode:setScale(0.95)

    hideGUI()
    core.createSkipButton(function()
                          for cur = 1,#coords do
                          itemOnPlace[cur] = 1
                          end
                          game.closeSubScene()
                          end
                          ,inActiveGame)
    --//
    if(notNeedToreorder == nil) then
        if(layerName == "frameMinigame")then
            for cur = 5000, 5000 + scene_members.activeArea:getChildrenCount() do
                local curChild = scene_members.activeArea:getChildByTag(cur)
                if(curChild ~= nil) then
                    scene_members.activeArea:reorderChild(curChild,cur-5000)
                    print("z order: ",curChild:getZOrder())
                end
            end
            else
            for cur = 1, scene_members.activeArea:getChildrenCount() do
                local curChild = scene_members.activeArea:getChildByTag(cur)
                if(curChild ~= nil) then
                    scene_members.activeArea:reorderChild(curChild,cur)
                    print("z order: ",curChild:getZOrder())
                end
            end
        end
    end
    
    function core.resetProgressButton()
        
        
        core.createSkipButton(function()
                              for cur = 1,#coords do
                              itemOnPlace[cur] = 1
                              end
                              game.closeSubScene()
                              end)
    end

	-- загрузка состояния мини-игры
	if not gameState.minigames then
		gameState.minigames = {}
	end
	if not gameState.minigames[sceneName] then
		gameState.minigames[sceneName] = {}
	end
	if not gameState.minigames[sceneName].coords then
		gameState.minigames[sceneName].coords = {}
	else
		parent = scene_members[layerName]
		for i, v in ipairs(gameState.minigames[sceneName].coords) do
			--item = parent:getChildByTag(i)
            if(layerName == "frameMinigame")then
                item = scene_members.activeArea:getChildByTag(i+5000)
                else
                item = scene_members.activeArea:getChildByTag(i)
            end
			--item = scene_members["item"..i]
			item:setPosition(ccp(v[1], v[2]))
			if v[1] == coords[i][1] and v[2] == coords[i][2] then
				itemOnPlace[i] = 1
				
				if onItemPlaced then
					onItemPlaced(item, itemTag, itemOnPlace)
				end
			end
			
		end
	end
	
	if(initAfterLoad) then initAfterLoad() end

	-- bounding box для мини-игры
	local bb_x,bb_y =  scene_members.activeArea:getPosition()
	local size = scene_members.activeArea:getContentSize()
	local bb_w = size.width
	local bb_h = size.height
	bb_x = 0 --bb_x - bb_w/2
	bb_y = 0 --bb_y - bb_h/2
	
-- переменные для текущего ухваченного предмета
	local item_dX, item_dY, itemTag
	local item_touchX, item_touchY
	local item_w2, item_h2

	function setupDraggableItem(sender)
			item_touchX, item_touchY = core.getLastTouchLocation(sender)
            if(layerName == "frameMinigame")then
                local maxOrder = 0
                for cur = 5000, 5000+scene_members.activeArea:getChildrenCount() do
                    local curChild = scene_members.activeArea:getChildByTag(cur)
                    if(curChild ~= nil) then
                        --scene_members.activeArea:reorderChild(curChild,cur)
                        local curOrder = curChild:getZOrder()
                        if(maxOrder< curOrder)then
                            maxOrder = curOrder
                        end
                        print("z order: ",curChild:getZOrder())
                    end
                    
                end
                scene_members.activeArea:reorderChild(sender,maxOrder + 1)
            end
			item_dX, item_dY = sender:getPosition()
			item_dX = item_dX - item_touchX;
			item_dY = item_dY - item_touchY;
            if(layerName == "frameMinigame")then
                itemTag = sender:getTag()-5000
                else
                itemTag = sender:getTag()
            end
			-- получаем половины размеров таскаемой картинки-кнопки
			local item_size = sender:getContentSize()
			item_w2 = item_size.width / 2
			item_h2 = item_size.height / 2  
	end
	
	function alignDraggableItem(sender)
		local x, y, dx, dy
		x,y = core.getLastTouchLocation(sender)
		-- получить разницу с предыдущим нажатием/драгом
		dx = x - item_touchX;
		dy = y - item_touchY;
		item_touchX = x
		item_touchY = y
		-- сменить позицию на такое значение
		local cur_x, cur_y
		cur_x, cur_y = sender:getPosition()
		
		cur_x = cur_x + dx-- + item_dX
		cur_y = cur_y + dy-- + item_dY
		
		-- подгоняем под bb
		if (cur_x < bb_x + item_w2) then
			cur_x = bb_x + item_w2
		end
		if (cur_y < bb_y + item_h2) then
			cur_y = bb_y + item_h2
		end
		if (cur_x > bb_x + bb_w - item_w2) then
			cur_x = bb_x + bb_w - item_w2
		end
		if (cur_y > bb_y + bb_h - item_h2) then
			cur_y = bb_y + bb_h - item_h2
		end
		
		sender:setPosition(ccp(cur_x,cur_y))
	
	end

-- отпускание предмета
	function dropItem(sender)
		-- вычисляем расстояние до правильного положения
		local x_right = coords[itemTag][1]
		local y_right = coords[itemTag][2]
		
		local cur_x, cur_y
		cur_x, cur_y = sender:getPosition()		
		local dist = math.sqrt((x_right-cur_x)*(x_right-cur_x) + (y_right-cur_y)*(y_right-cur_y))
		-- подровнять
		if (dist < 30) then
			sender:setPosition(ccp(x_right,y_right))			
			sender:runAction(CCSequence:createWithTwoActions(CCScaleTo:create(0.1,1.1),CCScaleTo:create(0.2,1)))			
		end
		-- проверяем - встало ли на место
		cur_x, cur_y = sender:getPosition()
		if (cur_x == x_right and cur_y == y_right) then
			itemOnPlace[itemTag] = 1
            --print("type: ", tolua.type(sender))
            sender:setTouchEnabled(false)
            if(layerName == "frameMinigame")then
                print("reoreder")
                print("oreder",sender:getZOrder())
                scene_members.activeArea:reorderChild(sender,0)
                print("orederafrer",sender:getZOrder())
            end
            if(notNeedToreorder == nil) then
                print("oreder",sender:getZOrder())
                scene_members.activeArea:reorderChild(sender,0)
            end
			if onItemPlaced then
				print("right!")
                --sender:setTouchEnabled(false)
				onItemPlaced(sender, itemTag, itemOnPlace)
                
			end
		else
			itemOnPlace[itemTag] = 0
		end
		-- посчитаем, сколько стоят на местах

		local items = 0
		for cur = 1,#coords do
			if (itemOnPlace[cur]) then
				items = items + itemOnPlace[cur]
			end
		end		
		--print("items on place: ", items)
		if (items == #coords) then
			if(succeedMiniGame) then
				game.closeSubScene()
				--succeedMiniGame()
			end
			
		end
		
	end
    
	-- функция-событие на предметы на столе мини-игры про куклу
	function scene_selectors.puzzleItemEvent(sender, action)
		tolua.cast(sender, "CCNode")
		--print(action)
		-- первичное нажатие
		if (action == 1) then
			setupDraggableItem(sender)
		end
		
		if (action == 2 or action == 4) then
			alignDraggableItem(sender)
		end
	
	
		if (action == 32) then -- отпускание
			dropItem(sender)
		end
	
	end

	--print(scene_selectors.puzzleItemEvent)
    for cur = 1,#coords do
        print("state",itemOnPlace[cur])
        local item = nil
        if(scene_members.activeArea == nil)then
            --return
        end
        if(layerName == "frameMinigame")then
            item = scene_members.activeArea:getChildByTag(cur+5000)
            else
            item = scene_members.activeArea:getChildByTag(cur)
        end
        if(core.getLastTouchLocation(item))then
            print("droping")
            if(layerName == "frameMinigame")then
                itemTag = item:getTag()-5000
                else
                itemTag = item:getTag()
            end
            dropItem(item)
        end
    end

end

local lang = CCApplication:sharedApplication():getCurrentLanguage()
--local lang = CCApplication:getCurrentLanguage(CCApplication:sharedApplication())

if(lang == 0) then
    core.executeScript("local/strings_en")
elseif(lang == 0) then
    core.executeScript("local/strings_en")
elseif(lang == 1) then
    core.executeScript("local/strings_en")
elseif(lang == 2) then
    core.executeScript("local/strings_en")
elseif(lang == 3) then
    core.executeScript("local/strings_en")
elseif(lang == 4) then
    core.executeScript("local/strings_de")
elseif(lang == 5) then
    core.executeScript("local/strings_es")
elseif(lang == 6) then
    core.executeScript("local/strings_ru")
elseif(lang == 7) then
    core.executeScript("local/strings_en")
end

core.resetscene();