-- autostart
-- core.*
-- scene_selectors
-- scene_members

sceneState = gameState.scene06;

-- включен ли хог
if sceneState.hogIsOn == nil then
	sceneState.hogIsOn = true
end
if not sceneState.doll then
	sceneState.doll = 0
end
if not sceneState.dollButton then
	sceneState.dollButton = 0
end

if not sceneState.dollDress then
	sceneState.dollDress = 0
end

if not sceneState.photopiece4 then
	sceneState.photopiece4 = 1
end

if not sceneState.ghost then
	sceneState.ghost = 0
end

if not sceneState.fuel then
	sceneState.fuel = 0
end

if not sceneState.fuelcan then
	sceneState.fuelcan = 0
end

if not sceneState.ropePlaced then
	sceneState.ropePlaced = 0
end


function showCurrentHint()
	
	if (sceneState.hogIsOn) then
		hintItem = scene_members.hoghint
		return
	end
	
    if (game.hasItem("boxcutter")) then
		hintItem = scene_members.ropehint
        return
	end
    
	if (game.hasItem("funnel")) then
		hintItem = scene_members.fuelhint
        return
	end
	
	if (sceneState.fuel == 1 and game.hasItem("hose")) then
		hintItem = scene_members.fuelhint
        return
	end
	
	if (sceneState.fuel == 2 and sceneState.fuelcan ~= 1) then
		hintItem = scene_members.fuelcan
        return
	end
	
	if sceneState.photopiece4 ~= 1 and sceneState.ghost == 1 then
		hintItem = scene_members.photopiece4
		return
	end
	
	if (sceneState.dollButton == 1 and sceneState.dollButton == 1 and sceneState.doll == 0) then
		hintItem = scene_members.dollhint
		return
	end
	
	if (sceneState.doll == 0 and (game.hasItem("dollbutton") or game.hasItem("dress"))) then
		hintItem = scene_members.dollhint
        return
	end
	
	hintItem = scene_members.exit
	
end



local function setRope()
	--rope
    scene_members.ropeLight:setVisible(sceneState.ropePlaced == 0)
	scene_members.sceneMenu:getChildByTag(101):setVisible(sceneState.ropePlaced == 0)
    
end


local function bringTheRope()
	game.addItem("rope")
	sceneState.ropePlaced = 1
    showDescription(LOCALIZE("S6_ROPECUT"))
	game.removeItem("boxcutter")
    effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0050_cutrope.mp3"))
	setRope()
end

local function loadHog()
	game.startSubScene("scene_6_0", scene_members.minigames, scene_members.sceneMenu)
	sceneHOGNum = 6;
    game.initCommonHog(scene06)
end

local function succeedDollGame()
	print("doll complete!")
	sceneState.photopiece4 = 0
	sceneState.ghost = 1
	sceneState.doll = 1
    scene_members.tableButton:setVisible(sceneState.doll == 0)
	scene_members.manGhostSprite:setVisible(true)
	scene_members.manParticles:setVisible(true)
	game.restartParticles(scene_members.explosionParticles)
	scene_members.photopiece4:setVisible(sceneState.photopiece4 == 0)
	scene_members.photopiece4:setTouchEnabled(sceneState.photopiece4 == 0)
	scene_members.dollPlaced:setVisible(sceneState.doll == 1)
	scene_members.dollGhost:setVisible(sceneState.doll == 0)
	scene_members.dollParts:setVisible(sceneState.doll == 0)
    effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0024_actionok.mp3"))
    showDescription(LOCALIZE("S6_DOLLGHOST"),2)
end

function scene_selectors.exitPressed(sender)
	if (gameState.exitActive == false) then
		return
	end
	
	game.startSceneWithSaveState("scene_4", "04_hallway", true);
end
local function checkDollGameComplete()
    if(sceneState.dollButton == 1 and sceneState.dollDress == 1)then
        core.resetProgressButton()
    end
end

function scene_selectors.ropePressed(sender)
    showDescription(LOCALIZE("S6_ROPE"))
    if(tmp.cut == 1) then
        
        bringTheRope()
    end
end

function scene_selectors.hogButtonPressed(sender)
  loadHog();  
    
end

function scene_selectors.tableButtonPressed(sender)
    --(sceneName, layerName, succeedMiniGame, coords, initAfterLoad, onCancelMinigame)
    showDescription(LOCALIZE("S6_DOLLPARTTS"))
    core.minigames.puzzle.loadMiniGame("scene_6_1", "dollMinigame", succeedDollGame, {{312, 229},{312, 348},{365,234},{257, 235},{360,133},{266,132},{333,358},{298,319},{312,218}},
                                       function()
                                       scene_members.item8:setVisible(sceneState.dollButton == 1);
                                       scene_members.item9:setVisible(sceneState.dollDress == 1)
                                       if(sceneState.dollButton == 1 and sceneState.dollDress == 1)then
                                       showDescription(LOCALIZE("S6_DOLLPARTTSFULL"))
                                       end
                                       checkDollGameComplete()                                
                                       end,nil,nil,1,1);
end

--[[function scene_selectors.sceneSelector(sender)
		tolua.cast(sender, "CCNode")
		local tag = sender:getTag()
		if (tag == 1) then
		print("running hog")
		loadHog();
		elseif (tag == 101) then
            showDescription(LOCALIZE("S6_ROPE"))
			if(tmp.cut == 1) then
                
				bringTheRope()
			end
		elseif (tag == 2) then
		--(sceneName, layerName, succeedMiniGame, coords, initAfterLoad, onCancelMinigame)
            showDescription(LOCALIZE("S6_DOLLPARTTS"))
			core.minigames.puzzle.loadMiniGame("scene_6_1", "dollMinigame", succeedDollGame, {{312, 229},{312, 348},{365,234},{257, 235},{360,133},{266,132},{333,358},{298,319},{312,218}},
			function()
				scene_members.item8:setVisible(sceneState.dollButton == 1);
				scene_members.item9:setVisible(sceneState.dollDress == 1)
               if(sceneState.dollButton == 1 or sceneState.dollDress == 1)then
                showDescription(LOCALIZE("S6_DOLLPARTTSFULL"))
               end
               checkDollGameComplete()                                
			end,nil,function() scene_members.item8 = nil end,1);
		
		end

end]]


--вставляеми воронку шланг и забираем канистру
local function canHoseFunnle()
    print("isideFunel")
	scene_members.fuelcan:setTouchEnabled(sceneState.fuel == 2)
    print("can",scene_members.fuelcan:isTouchEnabled())
	scene_members.hosePlaced:setVisible(sceneState.fuel == 2)
	scene_members.tankGhost:setVisible(sceneState.fuel < 2)
	scene_members.funnelPlaced:setVisible(sceneState.fuel >= 1 and sceneState.fuel < 3)
	if(sceneState.fuel == 3) then
		scene_members.fuelcan:setVisible(false)
	end

end


function inventoryItemUsed(it, x, y, action, sender)
	print("item used: ", it, x, y, action, sender)
	if(it == "boxcutter") then
		tmp.cut = 1
		game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.rope,bringTheRope,action)
	end
	if(it == "dollbutton") then
		game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.activeArea,
																			   function()
                                                                                if(scene_members.item8 == nil)then return end
																			   sceneState.dollButton = 1
																			   scene_members.item8:setVisible(sceneState.dollButton == 1);
																			   game.removeItem("dollbutton")
                                                                                checkDollGameComplete()
																			   end,action)
	end
	if(it == "dress") then
		game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.activeArea,function()
                                                                                if(scene_members.item8 == nil)then return end
																			   sceneState.dollDress = 1
																			   scene_members.item9:setVisible(sceneState.dollDress == 1);
																			   game.removeItem("dress")
                                                                                checkDollGameComplete()
																				end,action)
	end
	if(it == "funnel") then
		game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.fuelcan,function()
												   if(sceneState.fuel ~= 0)then return end
												   sceneState.fuel = 1
                                                    showDescription(LOCALIZE("S6_FUNNEL"),2)
												   canHoseFunnle()
												   game.removeItem("funnel")
												   end,action)
	end
	if(it == "hose") then
		game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.tankGhost,function()
												   if(sceneState.fuel ~= 1)then return end
												   sceneState.fuel = 2
												   canHoseFunnle()
                                                    showDescription(LOCALIZE("S6_HOSE"),2)
												   game.removeItem("hose")
												   end,action)
	end

end


function updateScreen()
    print("fuelState",gameState.scene06.fuel)
	if(sceneState.fuelcan == 1) then
		sceneState.fuel = 3
		canHoseFunnle()
	end

end



function onTouchLayer(eventType, x, y)
    print("working")
    if eventType == CCTOUCHBEGAN then
        print(x,y)
        game.doActionOnScene(x,y,scene_members.fuelcan,function()
                             showDescription(LOCALIZE("S6_CAN"),2)
                             end)
        game.doActionOnScene(x,y,scene_members.tankGhost,function()
                                showDescription(LOCALIZE("S6_CAN"),2)
                            end)
        game.doActionOnScene(x,y,scene_members.manGhostSprite,function()
                                if(sceneState.ghost == 1)then
                                    showDescription(LOCALIZE("S6_DOLLGHOST"),2)
                                end
                            end)

    end
end

function event()
	updateScreen()
	canHoseFunnle()
	--hog
	scene_members.hogParticles:setVisible(sceneState.hogIsOn)
    scene_members.hogButton:setEnabled(sceneState.hogIsOn)

    setRope()
	
	--doll
	scene_members.dollPlaced:setVisible(sceneState.doll == 1)
	scene_members.dollGhost:setVisible(sceneState.doll == 0)
	scene_members.dollParts:setVisible(sceneState.doll == 0)
    scene_members.tableButton:setVisible(sceneState.doll == 0)

	--ghost
	scene_members.manGhostSprite:setVisible(sceneState.ghost == 1)
	scene_members.manParticles:setVisible(sceneState.ghost == 1)
	scene_members.explosionParticles:setVisible(sceneState.ghost == 1)

	--picture
	scene_members.photopiece4:setVisible(sceneState.photopiece4 == 0)
	scene_members.photopiece4:setTouchEnabled(sceneState.photopiece4 == 0)
    
end

