-- autostart
-- core.*
-- scene_selectors
-- scene_members

-- включен ли хог
sceneState = gameState.scene07;
game.isSceneNeedProcessDialog = true

-- включен ли хог
if sceneState.hogIsOn == nil then
	sceneState.hogIsOn = true
end

if not sceneState.girlcrystal then
	sceneState.girlcrystal = 1
end

if not sceneState.photopiece5 then
	sceneState.photopiece5 = 1
end

if not sceneState.ghost then
	sceneState.ghost = 0
end

if not sceneState.cloth then
	sceneState.cloth = 0
end
if not sceneState.drawing then
	sceneState.drawing = 0
end

if not sceneState.fullPhoto then
	sceneState.fullPhoto = 0
end

if not sceneState.photoGameOpen then
	sceneState.photoGameOpen = 0
end

if not sceneState.crystalTaken then
	sceneState.crystalTaken = 0
end

if not sceneState.filmStarted then
	sceneState.filmStarted = 0
end


if not sceneState.DialogStarted then
	sceneState.DialogStarted = 0
end


function showCurrentHint()
    
	if (sceneState.hogIsOn) then
		hintItem = scene_members.hoghint
		return
	end
	
	if (sceneState.cloth ~= 1) then
		hintItem = scene_members.chesthint
		return
	end

	if (sceneState.photopiece5 ~= 1 and sceneState.ghost == 1) then
		hintItem = scene_members.photopiece5
		return
	end
	
	if (sceneState.ghost == 0 and game.hasItem("drawing")) then
		hintItem = scene_members.albumhint
		return
	end
	
	if (sceneState.ghost == 0 and sceneState.drawing == 1) then
		hintItem = scene_members.albumhint
		return
	end
	
	
	if (game.hasItem("photopiece",6) or sceneState.photoGameOpen == 1) then
		hintItem = scene_members.photohint
		return
	end
	
	if (sceneState.girlcrystal == 0) then
		hintItem = scene_members.girlcrystal
		return
	end
	
	hintItem = scene_members.exit
	
end

local function loadHog()
	game.startSubScene("scene_7_0", scene_members.minigames, scene_members.sceneMenu)
	sceneHOGNum = 7;
    game.initCommonHog(scene07)
end



local function openChest()
    specificSounOnOpen = true
	game.initSubScene("scene_7_1","chest")
    effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0060_woodrustyopen.mp3"))
	scene_members.cloth:setVisible(sceneState.cloth == 0)
	scene_members.cloth:setTouchEnabled(sceneState.cloth == 0)
end

local function succeedFrameGame()
	print("frame complete!!")
    core.sendFlurryEvent("Level_<Level02>_Complete")
    sceneState.photoGameOpen = 0
    sceneState.crystalTaken = 1
    sceneState.filmStarted = 1
    scene_members.sceneMenu:getChildByTag(3):setEnabled(false)
    runFinalClip("cutScene2part","scene_7", "07_playroom",sceneState.cutMovie,5,sceneState.ghost,"S7_DIALOG1","S7_DIALOG2",sceneState.girlcrystal,"girlcrystal","scene07")
end

local function runAlbumGame()
    showDescription(LOCALIZE("S7_PHOTOPARTS"),1)
    core.minigames.puzzle.loadMiniGame("scene_7_2", "frameMinigame", succeedFrameGame, {{216,309},{329, 271},{492, 284},{496,135},{297,149},{115,192},{95,66},{259,70},{502,70}});
end



local function succeedApplicationGame()
	print("application complete!")
	sceneState.photopiece5 = 0
	sceneState.ghost = 1
	scene_members.manGhostSprite:setVisible(true)
	scene_members.manParticles:setVisible(true)
	game.restartParticles(scene_members.explosionParticles)
	scene_members.photopiece5:setVisible(sceneState.photopiece5 == 0)
	scene_members.photopiece5:setTouchEnabled(sceneState.photopiece5 == 0)
	scene_members.fullsistersPic:setVisible(sceneState.girlcrystal == 0)
	scene_members.sisterPhotoGhost:setVisible(sceneState.girlcrystal == 1)
    scene_members.sceneMenu:getChildByTag(4):setVisible(sceneState.ghost == 0)
    showDescription(LOCALIZE("S7_SHOWNOTEBOOKGHOST"),2)
    effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0024_actionok.mp3"))
	
end


function scene_selectors.exitPressed(sender)
	if (gameState.exitActive == false) then
		return
	end
	
	game.startSceneWithSaveState("scene_4", "04_hallway", true);
end

function scene_selectors.hogPressed(sender)
    loadHog()
end

function scene_selectors.chestPressed(sender)
    openChest()
end

function scene_selectors.frameGamePressed(sender)
    showDescription(LOCALIZE("S7_PHOTOFRAME"))
    if(sceneState.fullPhoto == 1)then
        runAlbumGame()
    end
end

function scene_selectors.albumGamePressed(sender)
    showDescription(LOCALIZE("S7_CUTPAINTING"),2)
    if(sceneState.drawing == 1) then
        showDescription(LOCALIZE("S7_FULLPAINTING"))
        effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0061_turnpapper.mp3"))
        core.minigames.puzzle.loadMiniGame("scene_7_3", "applicationMinigame", succeedApplicationGame, {{456,326},{416, 199},{87, 360},{175,210},{157,258},{214,149},{149,133},{318,296},{303,399},{299,419},{353,161},{263,161},{309,217},{225,396}},nil,nil,nil,nil,1);
    end
end


--[[function scene_selectors.sceneSelector(sender)
tolua.cast(sender, "CCNode")
		local tag = sender:getTag()
		if(tag == 1) then
			print("loadHog")
				loadHog()
			elseif(tag == 2) then 
				openChest()
			elseif (tag == 3) then
             showDescription(LOCALIZE("S7_PHOTOFRAME"))
                if(sceneState.fullPhoto == 1)then
                    runAlbumGame()
                end
            
			elseif tag == 4 then
            showDescription(LOCALIZE("S7_CUTPAINTING"))
				if(sceneState.drawing == 1) then
                     showDescription(LOCALIZE("S7_FULLPAINTING"))
                    effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0061_turnpapper.mp3"))
					core.minigames.puzzle.loadMiniGame("scene_7_3", "applicationMinigame", succeedApplicationGame, {{456,326},{416, 199},{87, 360},{175,210},{157,258},{214,149},{149,133},{318,296},{303,399},{299,419},{353,161},{263,161},{309,217},{225,396}});
				end
		end

end]]



local function addDrawingToNoteBook()
	sceneState.drawing = 1
	game.removeItem("drawing")
    scene_members.fullDrawing:setVisible(true)
end

function inventoryItemUsed(it, x, y, action, sender)
	print("item used: ", it, x, y, action, sender)
	if(it == "photopiece") then
		tmp.drawing = 1
		game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.fullsistersPic, function()
                                                                                    sceneState.fullPhoto = 1
                                                   sceneState.photoGameOpen = 1
                                                   scene_members.sceneMenu:getChildByTag(3):setVisible(true)
                                                   scene_members.sceneMenu:getChildByTag(3):setEnabled(true)
                                                   scene_members.fullsistersPic:setVisible(sceneState.fullPhoto == 1)
																					print("runalbum222")
												   									runAlbumGame()
                                                                                    game.removeItem("photopiece",6)
																					end,action)
		
	end
	if(it == "drawing") then
		game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.drawingPiece,addDrawingToNoteBook,action)
	end
end

function onTouchLayer(eventType, x, y)
    print("working")
    if eventType == CCTOUCHBEGAN then
        print(x,y)
        game.doActionOnScene(x,y,scene_members.sisterPhotoGhost,function()
                                                                    if(sceneState.crystalTaken == 0) then
                                                                         showDescription(LOCALIZE("S7_PHOTOFRAME"),2)
                                                                    end
                                                                end)
        game.doActionOnScene(x,y,scene_members.manGhostSprite,function()
                                                                    if(sceneState.ghost == 1) then
                                                                        showDescription(LOCALIZE("S7_SHOWNOTEBOOKGHOST"),2)
                                                                    end
                                                                end)

    end
end



--debug
--function scene_selectors.sceneSelector(sender)
    --succeedFrameGame()
    --runAlbumGame()
--end
--end debug


function updateScreen()
    scene_members.chestGhost:setVisible(sceneState.cloth == 0)
    
end

function event()
	--crystal
    
    print("table: ",sceneState.girlcrystal)
	scene_members.girlcrystal:setVisible(sceneState.girlcrystal == 0)
	scene_members.girlcrystal:setVisible(sceneState.girlcrystal == 0)
	--ghost
	scene_members.manGhostSprite:setVisible(sceneState.ghost == 1)
	scene_members.manParticles:setVisible(sceneState.ghost == 1)
	scene_members.explosionParticles:setVisible(sceneState.ghost == 1)
    
    scene_members.sceneMenu:getChildByTag(4):setVisible(sceneState.ghost == 0)
    --scene_members.sceneMenu:getChildByTag(3):setVisible(sceneState.fullPhoto == 1)
    --scene_members.sceneMenu:getChildByTag(3):setEnabled(sceneState.fullPhoto == 1)
    scene_members.sceneMenu:getChildByTag(3):setVisible(sceneState.photoGameOpen == 1)
    scene_members.sceneMenu:getChildByTag(3):setEnabled(sceneState.photoGameOpen == 1)
    
    
	
	--picture
	scene_members.photopiece5:setVisible(sceneState.photopiece5 == 0)
	scene_members.photopiece5:setTouchEnabled(sceneState.photopiece5 == 0)

    scene_members.hogParticles:setVisible(sceneState.hogIsOn)
    scene_members.hogButton:setEnabled(sceneState.hogIsOn)
    
	--notebook
	scene_members.noteBookGhost:setVisible(sceneState.drawing == 0)
	scene_members.fullDrawing:setVisible(sceneState.drawing == 1)
	scene_members.drawingPiece:setVisible(sceneState.drawing == 0)
	--pic
	scene_members.fullsistersPic:setVisible(sceneState.girlcrystal == 0)
	--chest
	scene_members.chestGhost:setVisible(sceneState.cloth == 0)
    
    print("notcircle:".. sceneState.filmStarted)
    scene_members.fullsistersPic:setVisible(sceneState.fullPhoto == 1)
    if(sceneState.filmStarted == 1) then
        print("inside film")
       sceneState.filmStarted = runFinalClip("cutScene2part","scene_7", "07_playroom",sceneState.cutMovie,5,sceneState.ghost,"S7_DIALOG1","S7_DIALOG2",sceneState.girlcrystal,"girlcrystal","scene07")
    end
    
    if(sceneState.DialogStarted == 1) then
        print("inside dialog")
      showDialog(sceneState.ghost,"S7_DIALOG1","S7_DIALOG2",sceneState.girlcrystal,"girlcrystal","scene07")  
    end

    
    
	
	 
end