-- autostart
-- core.*
-- scene_selectors
-- scene_members

-- разбито ли стекло

sceneState = gameState.scene08;

if sceneState.smashed == nil then
    sceneState.smashed = 0
end

if sceneState.ghostShown == nil then
    sceneState.ghostShown  = 0
end

-- потушен ли огонь
if sceneState.fireDown == nil then
	sceneState.fireDown = 0
end

-- длинный шкаф
if sceneState.lockerOpened == nil then
	sceneState.lockerOpened = 0
end

-- распилен ли замок
if sceneState.doorOpen == nil then
	sceneState.doorOpen = 0
end
if not sceneState.firstStart then
	sceneState.firstStart = 1
    core.sendFlurryEvent("Level_<Level03>_Start")
end

function showCurrentHint()

	--[[
	
	 если горит огонь
	 	если нет молотка
	 		- шкафчик
		иначе
	 		- рычаг
	 	конец
	 иначе
	 	если не взят ключик
	 		-дырка в полу
	 	конец
	 	если есть ключ от шкафчика
	 		-шкафчик
		конец
	 	если висит замок
	 		если есть пила
	 			-замок
	 		иначе
	 			-лестница
	 		конец
	 	конец
	 конец
	 -выход
	 
	]]
	
	if (sceneState.fireDown == 0) then
		if (sceneState.hammer == 1) then
			hintItem = scene_members.alarmhint
			return
		else
			hintItem = scene_members.closethint
			return
		end
	else

		if (sceneState.carkey ~= 1) then
			-- дырка в полу
			hintItem = scene_members.tilehint
			return
		end
		
		if (sceneState.lockerOpened == 0) then
			if (game.hasItem("lockerkey")) then
				hintItem = scene_members.lockerhint
				return
			end
		else
			if (sceneState.slide1~=1 or sceneState.candle~=1) then
				hintItem = scene_members.lockerhint
				return
			end
		end

		if (sceneState.doorOpen ~=1) then
			if (game.hasItem("ironsaw")) then
				hintItem = scene_members.padlockGhostSprite
				return
			else
				hintItem = scene_members.stairwayhint
				return
			end
		end
	end
	
	if (sceneState.doorOpen == 1) then
		game.addExit(scene_members.doorhint)
	end
	game.addExit(scene_members.stairwayhint)
	game.addExit(scene_members.exit)
	
end

-- обновение экрана после каких-то действий
function updateScreen()
	-- locker
	if (sceneState.hammer) then
		scene_members.lockerOpened:setVisible(sceneState.hammer == 1)
		scene_members.lockerGhostSprite:setVisible(not (sceneState.hammer == 1))
    	scene_members.lockerButton:setEnabled(not (sceneState.hammer == 1))
    end
	-- alarm
    scene_members.alarmOnSprite:setVisible(sceneState.smashed >= 4)
	scene_members.alarmGhostSprite:setVisible(not (sceneState.smashed >= 4))
    scene_members.alarmButton:setEnabled(not (sceneState.smashed >= 4))
	
	-- tile
    local openTile = sceneState.fireDown == 1 and (not sceneState.carkey)
	
    scene_members.tileGhostSprite:setVisible(openTile)
	scene_members.tileButton:setVisible(openTile)
	scene_members.tileButton:setEnabled(openTile)
	
	if (sceneState.carkey) then
		scene_members.removedTileSprite:setVisible(true)
	end
	
	-- padlock
	scene_members.padlockGhostSprite:setVisible(sceneState.fireDown == 1 and sceneState.doorOpen ~= 1)
    scene_members.padlockButton:setEnabled(sceneState.fireDown == 1 and sceneState.doorOpen ~= 1)
	
	print("door open ", sceneState.doorOpen)
	scene_members.yardButton:setVisible(sceneState.doorOpen == 1)
    -- шумит ветер
    if(sceneState.doorOpen == 1)then
        effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/amb/a_1012_verylowwind.mp3"), true)
    end
	
	-- long locker
	if (sceneState.lockerOpened == 0) then
		-- long locker
		scene_members.lockerOpenSprite:setVisible(false)
		scene_members.longLockerGhostSprite1:setVisible(true)
		scene_members.longLockerGhostSprite2:setVisible(false)
	else
		scene_members.lockerOpenSprite:setVisible(true)
		scene_members.longLockerGhostSprite1:setVisible(false)
		scene_members.longLockerGhostSprite2:setVisible(true)
		
		if sceneState.slide1 == 1 and sceneState.candle == 1 then
			scene_members.longLockerGhostSprite2:setVisible(false)
			scene_members.longlockerButton:setEnabled(false)
		end
		
	end
    --firesound
    if(sceneState.fireDown == 1)then
        if(fireEffectID ~=nil)then
            SimpleAudioEngine:sharedEngine():stopEffect(fireEffectID)
            if(waterEffectID == nil) then
                waterEffectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0071_watersprinklers.mp3"))
            end
        end
    else
        if(tmp.fireSound == nil) then
            fireEffectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/amb/a_1013_onfire.mp3"),true)
            tmp.fireSound = 1
        end
    end
	
end

-- обновление после удара по стеклу
local function updateAlarm()
    -- alarm: turn everyting on
    print("smash!! ", sceneState.smashed)
    
    -- cracks
    scene_members.glassSprite:setVisible(sceneState.smashed <=2)
    scene_members.crackSprite1:setVisible(sceneState.smashed > 0 and sceneState.smashed < 3)
    scene_members.crackSprite2:setVisible(sceneState.smashed == 2 )
    scene_members.leverMovedSprite:setVisible(sceneState.smashed >= 4)
	-- потому что при открытии заново, окно опять разлетается
	--if sceneState.smashed < 3 then
		-- shards
		scene_members.shardsParticles:setVisible(false)
	--end
	
	if sceneState.smashed == 3 then
        if( not sceneState.widowBroken)then
            scene_members.shardsParticles:setVisible(true) 
            game.restartParticles(scene_members.shardsParticles)
            sceneState.widowBroken = 1
        end
        showDescription(LOCALIZE("S8_BROKEALARMGLASS"))

	end
	
	if sceneState.smashed == 4 then
		-- smash fire alarm
		scene_members.waterSprite:setVisible(true)
		scene_members.waterSprite:runAction(CCFadeIn:create(3))
		
		sceneState.smashed = sceneState.smashed + 1
		sceneState.fireDown = 1
		
		firewall = scene_members.firewallParticles
		
		tolua.cast(firewall, "CCParticleSystemQuad")
		firewall:setDuration(1)
		
        game.restartParticles(scene_members.waterParticles)
		
		updateScreen()
		effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0068_alarma.mp3"))
		game.closeSubSceneInTime(0.5)
		
		game.removeItem("hammer")
		
	end
end

function showGhost()
	-- run ghost
	scene_members.manGhostSprite:setVisible(true)
	scene_members.manParticles:setVisible(true)
	game.restartParticles(scene_members.explosionParticles)
	scene_members.ghostButton:setEnabled(true)
	
	sceneState.ghostShown = 1
end

function scene_selectors.lockerPressed(sender)
    specificSounOnOpen = true
    game.initSubScene("scene_8_1", "lockerWindow")
    effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0039_rustquick.mp3"))
    
end

function scene_selectors.ghostPressed(sender)
	if sceneState.showGhost then
		showDescription(LOCALIZE("S8_GHOST"),2)
	end
end

function scene_selectors.tilePressed(sender)
    specificSounOnOpen = true
    game.initSubScene("scene_8_3", "tileWindow")
    effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0039_rustquick.mp3"))
end

function scene_selectors.padlockPressed(sender)
	showDescription(LOCALIZE("S8_LOCK"),2)
    
end

function scene_selectors.alarmPressed(sender)
	if sceneState.hammer then
		--showDescription("Стекло можно расколотить молотком!")
	else
		--showDescription("Вот бы чем-нибудь жахнуть по стеклу...")
        showDescription(LOCALIZE("S8_ALARM"))
	end
    showDescription(LOCALIZE("S8_ALARM"))
    game.initSubScene("scene_8_2", "alarmWindow")
    updateAlarm()
end




function scene_selectors.exitPressed(sender)
	if (gameState.exitActive == false) then
		return
	end

	--startScene("scene_2", "02_crossroad", true);
	game.startSceneWithSaveState("scene_2", "02_crossroad", true);
end

function scene_selectors.stairwayPressed(sender)
	print("exit")
    game.startSceneWithSaveState("scene_9", "09_classroom", true);
    effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0025_navigate.mp3"))
end

function scene_selectors.yardPressed(sender)
    game.startSceneWithSaveState("scene_10", "10_yard", true);
end

function scene_selectors.longlockerPressed(sender)
	-- check if we have a key
	
	if sceneState.lockerOpened == 0 then
		--showDescription("Шкафчик заперт на ключ",2)
        showDescription(LOCALIZE("S8_CASE"),2)
	end

	if sceneState.lockerOpened == 1 then
		game.initSubScene("scene_8_4", "longlockerWindow")
		
		if sceneState.slide1 == 1 then
            scene_members.slide1:removeFromParentAndCleanup(true);
        end
		if sceneState.candle == 1 then
            scene_members.candle:removeFromParentAndCleanup(true);
        end

		
	end
end

-- удар молотком
local function hammerRelease()
    sceneState.smashed = sceneState.smashed + 1
    effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0067_glasscrackle.mp3"))
    updateAlarm()
end

-- пилить пилой
local function unlockDoor()
    print("unlock!")
    sceneState.doorOpen = 1
    effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0036_openrustylong.mp3"))
    scene_members.closedDoorSprite:runAction(CCFadeOut:create(0.3))
    showDescription(LOCALIZE("S8_DOOR"))
    
    
    updateScreen()
end

local function useSaw()
	print("use saw")
    local data = itemsInformation.ironsaw
    local saw = CCSprite:create(data[1])
    scene_members.inventory:addChild(saw, 1001)
    saw:setPosition(itemSprite:getPosition())
    saw:setPositionY(saw:getPositionY()-GAME_INVENTORY_ITEM_SHIFT_POSITION)
    game.diagonalAnimation(saw, unlockDoor)
    effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0069_hacksawslide.mp3"))
    --unlockDoor()
	game.removeItem("ironsaw")
end

function openLocker()
	sceneState.lockerOpened = 1
	showGhost()
	updateScreen()
    effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0024_actionok.mp3"))
	game.removeItem("lockerkey")
    showDescription(LOCALIZE("S8_GHOST"))
end

-- использован предмет инвентаря
function inventoryItemUsed(it, x, y, action, sender)
    
	if (it == "lockerkey" and action == 64) then
        game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.lockerOpenSprite,openLocker, 64)
    end
	
    if (it == "hammer" and action == 64) then
        game.enablesItemfromInventory(x,y,scene_members.glassSprite,hammerRelease, 64)
    end
    
    -- game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.ghostTireOnTree,setRopeToTheTree,action)
    if (it == "ironsaw" and action == 64) then
        if(sceneState.fireDown == 1)then
            local used = game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.padlockGhostSprite,useSaw,action)
            --return used
        end
    end
end

function scene_selectors.alarmButtonPressed(sender)
    
    if sceneState.smashed == 3 then
        hammerRelease()
    end
    
    if sceneState.smashed >= 4 then
        -- close here
        game.closeSubSceneInTime(1)
        updateScreen()
    end
end

-- апдейт при входе на сцену
function event()
	print("college scene event!")
    -- opened locker

 	-- firewall
	scene_members.firewallParticles:setVisible(sceneState.fireDown == 0)
	-- water
	scene_members.waterSprite:setVisible(sceneState.fireDown == 1)
	-- man ghost

	scene_members.manGhostSprite:setVisible(sceneState.slide1 == 1)
	scene_members.manParticles:setVisible(sceneState.slide1 == 1)
	scene_members.ghostButton:setEnabled(sceneState.slide1 == 1)
	scene_members.explosionParticles:setVisible(false)
	
    -- door

     scene_members.closedDoorSprite:setVisible(not (sceneState.doorOpen == 1))
    
	updateScreen()
    
end

--описание на сцене
function onTouchLayer(eventType, x, y)
    print("working")
    if eventType == CCTOUCHBEGAN then
        print(x,y)
        game.doActionOnScene(x,y,scene_members.yardButton,function()
                                                                if(true) then
                                                                    showDescription(LOCALIZE("S8_FIRE"),2)
                                                                end
                                                                end)

    end
end
