-- autostart
-- core.*
-- scene_selectors
-- scene_members

sceneState = gameState.scene09
game.isSceneNeedProcessDialog = true

-- опущены ли шторы (сыграна мини-игра)
if sceneState.darkness == nil then
    sceneState.darkness = 0
end

-- нарисовано ли сердце мелом
if sceneState.heart == nil then
	sceneState.heart = 0
end

-- какой слайд показывать
if sceneState.slideNumber == nil then
	sceneState.slideNumber = 0
end

-- включен ли хог
if sceneState.hogIsOn == nil then
	sceneState.hogIsOn = true
end

if sceneState.slideTaken == nil then
	sceneState.slideTaken = false
end

if sceneState.chalkUsed == nil then
	sceneState.chalkUsed = false
end
--показывать ли кристалл
if not sceneState.boycrystal then
	sceneState.boycrystal = 1
end

if not sceneState.filmStarted then
	sceneState.filmStarted = 0
end


if not sceneState.DialogStarted then
	sceneState.DialogStarted = 0
end


function showCurrentHint()

	if (sceneState.hogIsOn) then
		print("hint1")
		hintItem = scene_members.hoghint
		return
	end
	
	
	if (sceneState.rose ~= 1) then
		print("hint2")		
		hintItem = scene_members.rose
		return
	end
	
	if (game.hasItem("dlever")) then
		print("hint3")		
		hintItem = scene_members.leverGhostSprite
		return
	end
	
	if (game.hasItem("slide1") or game.hasItem("slide2") or game.hasItem("slide3") or game.hasItem("slide4") or game.hasItem("slide5")) then
		print("hint4")		
		hintItem = scene_members.projectorGhostSprite
		return
	end
	
	if ((not sceneState.chalkUsed) and game.hasItem("chalk")) then
		print("hint5")		
		hintItem = scene_members.chalkhint
		return
	end
	
	if (sceneState.chalkUsed and sceneState.slide2 == 0) then
		print("hint6")		
		hintItem = scene_members.slide2
		return
	end
	
	if (sceneState.boycrystal == 0) then
		print("hint7")		
		hintItem = scene_members.boycrystal
		return
	end
	
	print("hint8")
	hintItem = scene_members.exit
	
	
	--[[
	 
	 если роза не взята
	 	- роза
	 конец
	 
	 если есть рукоятка в инвентаре
	 	- показать шкафчик
	 конец
	 
	 если активный хог
	 	- показать на хог
	 end
	 
	 если есть слайды
	 	- показать на проектор
	 end
	 
	 если есть мелок
	 	- показать на доску
	 end
	 
	 показать на выход
	 
	 ]]
	
end

-- обновение экрана после каких-то действий
function updateScreen()

	-- switch off lever ghost & lever button
    scene_members.leverGhostSprite:setVisible(sceneState.darkness == 0)
    scene_members.leverButton:setEnabled(sceneState.darkness == 0)
	
	
    -- switch off projector ghost

    scene_members.projectorGhostSprite:setVisible(sceneState.slideNumber < 5)
    
	-- switch off slide
	if (not (sceneState.slide2 == 1)) then
		scene_members.slide2:setVisible(sceneState.chalkUsed)
    end
    -- chalk used (heart)
    scene_members.chalkHeartSprite:setVisible(sceneState.chalkUsed)
	
end


function showGhost()
	-- run ghost
    effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0082_chalk.mp3"))
    showDescription(LOCALIZE("S9_GHOST"),2)
    sceneState.slide2 = 0
    
	scene_members.manGhostSprite:setVisible(true)
	game.restartParticles(scene_members.explosionParticles)
	scene_members.ghostButton:setEnabled(true)
	
    sceneState.chalkUsed = true
    game.removeItem("chalk")
    
    updateScreen()
end

local function leverSetup()
	scene_members.leverSprite:setVisible(true)
    effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0076_reellever.mp3"))
	core.runAnimation("rotation",0,scene_members.leverWindow)
	sceneState.darkness = 1
	print("lever setup")
    
	scene_members.projectorBackSprite:setVisible(true)
	scene_members.projectorBackSprite:runAction(CCFadeIn:create(2))
    scene_members.projectorBackSprite:runAction(CCSequence:createWithTwoActions(CCDelayTime:create(2), CCCallFunc:create(function()
                                                                                                                     effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0110_activatespotlight.mp3"))
                                                                                                                           end)))
    
	updateScreen()
	game.removeItem("dlever")
	game.closeSubSceneInTime(1)
end

local function resetSlides()
    for cur = 1, 5 do
        -- show slides in projector
        scene_members["pslideSprite"..cur]:setVisible(cur < (sceneState.slideNumber + 1))
        scene_members["slideSprite"..cur]:setVisible(cur < (sceneState.slideNumber + 1))
    end
end

local lastSlide

local function addSlide()
	if sceneState.darkness == 0 or sceneState.slideNumber == 5 then
		return
	end
	effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0003_click.mp3"))
	game.removeItem(lastSlide)
	
    sceneState.slideNumber = sceneState.slideNumber + 1
    -- reset all slides
    resetSlides()
    showDescription(LOCALIZE("S10_MEMORIES"..sceneState.slideNumber))
    -- show current slide on screen
    scene_members["slideSprite"..sceneState.slideNumber]:setVisible(true)
    scene_members["slideSprite"..sceneState.slideNumber]:setOpacity(0)
    scene_members["slideSprite"..sceneState.slideNumber]:runAction(CCFadeIn:create(0.2))
    if(sceneState.slideNumber == 5) then
        core.sendFlurryEvent("Level_<Level03>_Complete")
        sceneState.filmStarted = 1
        runFinalClip("cutScene3part","scene_9", "09_classroom",sceneState.cutMovie,8,sceneState.ghost,"S9_DIALOG1","S9_DIALOG2",sceneState.boycrystal,"boycrystal","scene09")
    end
    
    --updateScreen()
    
end

-- использован предмет инвентаря
function inventoryItemUsed(it, x, y, action, sender)
    
--    if (it == "hammer" and action == 64) then
	if (action == 64) then	
        if it == "dlever" then
            game.enablesItemfromInventory(x,y,scene_members.leverSprite,leverSetup, 64)
        end
        
        if it == "chalk" then
            game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.chalkPlaceSprite,showGhost, 64)
        end
        
        if it == "slide1" or it == "slide2" or it == "slide3" or it == "slide4" or it == "slide5" then
			lastSlide = it
            game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.projectorButton,addSlide,action)

        end
        
    end
    
end

function scene_selectors.ghostPressed(sender)
	if sceneState.showGhost then
		showDescription(LOCALIZE("S9_GHOST"),2)
	end
	--
end

function scene_selectors.boardPressed(sender)
	showDescription(LOCALIZE("S9_BOARD"),2)
	--
    
end

function scene_selectors.leverPressed(sender)
    if sceneState.darkness == 0 then
        game.initSubScene("scene_9_1", "leverWindow")
        scene_members.leverSprite:setVisible(false)
        showDescription(LOCALIZE("S9_LEVER"))
    end
end

function scene_selectors.projectorPressed(sender)
	print("projector pressed ", sceneState.darkness)
    
    if sceneState.darkness == 1 then
        showDescription(LOCALIZE("S10_PROJECTOR"),2)
    end
    
	if sceneState.darkness == 0 then
		showDescription(LOCALIZE("S9_LIGHT"),2)
	end
	
end

function scene_selectors.hogPressed(sender)
-- hog start here
    local m = scene_members;
    local gs = gameState.scene09;
    
    game.startSubScene("scene_9_hog", m.minigames, scene_members.sceneMenu)

    sceneHOGNum = 9;
 
    game.initCommonHog(scene09)
	-- _G[]
end

function onTouchLayer(eventType, x, y)
    print("working")
    if eventType == CCTOUCHBEGAN then
        print(x,y)
    end
end


function scene_selectors.exitPressed(sender)
	if (gameState.exitActive == false) then
		return
	end

	game.startSceneWithSaveState("scene_8", "08_college", true);
end

-- апдейт при входе на сцену
function event()
	print("classroom scene event! ", sceneState.darkness)
    -- showGhost

 	scene_members.manGhostSprite:setVisible(sceneState.chalkUsed)
	
    --crystal
	scene_members.boycrystal:setVisible(sceneState.boycrystal == 0)
	scene_members.boycrystal:setVisible(sceneState.boycrystal == 0)
    
    
    -- выключен свет
	if sceneState.darkness == 1 then
		-- init darkness
		scene_members.projectorBackSprite:setVisible(true)
        effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/amb/a_1014_projectoron.mp3"),true)
	end
    
	if sceneState.rose == 1 then
		scene_members.rose:removeFromParentAndCleanup(true);
	end
	
	if sceneState.slide2 == 1 then
		scene_members.slide2:removeFromParentAndCleanup(true);
	end
	
    resetSlides()
	updateScreen()
    
    if(sceneState.filmStarted == 1) then
        sceneState.filmStarted = runFinalClip("cutScene3part","scene_9", "09_classroom",sceneState.cutMovie,8,sceneState.ghost,"S9_DIALOG1","S9_DIALOG2",sceneState.boycrystal,"boycrystal","scene09")
    end
    
    if(sceneState.DialogStarted == 1) then
        showDialog(sceneState.ghost,"S9_DIALOG1","S9_DIALOG2",sceneState.boycrystal,"boycrystal","scene09")
    end
    

end
