-- autostart
-- core.*
-- scene_selectors
-- scene_members

sceneState = gameState.scene10

-- состояние автомобиля
if sceneState.car == nil then
    sceneState.car = 0
end

-- вырезано ли сердце на дереве
if sceneState.heartComplete == nil then
	sceneState.heartComplete = 0
end

if sceneState.carjack == nil then
    sceneState.carjack = 0
end

-- показывать ли призрака
if sceneState.showGhost == nil then
    sceneState.showGhost = false
end

-- починена ли гитара
if sceneState.guitarFixed == nil then
	sceneState.guitarFixed = false
end

-- установлена ли лестница
if sceneState.ladderSet == nil then
	sceneState.ladderSet = false
end

-- установлена ли свеча
if sceneState.candleSet == nil then
	sceneState.candleSet = false
end

-- зажжена ли свеча
if sceneState.candleLightSet == nil then
	sceneState.candleLightSet = false
end

if not sceneState.collegeticketPicked then
	sceneState.collegeticketPicked = false
end

function game.onSceneStartCustom()
    --шумит ветер
    effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/amb/a_1010_windhighpitch1.mp3"), true)
end



function showCurrentHint()

	
	if ((sceneState.guitarFixed == false) and (sceneState.string1 ~= 1)) then
		hintItem = scene_members.pedestalGhostSprite
		return
	end
    if (sceneState.car==1 ) then
		hintItem = scene_members.carSprite2
		return
	end
	
	if (game.hasItem("carkey")) then
		hintItem = scene_members.carSprite1
		return
	end
	
	if (game.hasItem("carjack")) then
		hintItem = scene_members.carSprite2
		return
	end
	
	
	if (not (sceneState.string2 == 1)) then
        print("inside")
		hintItem = scene_members.carSprite3
		return
	end
	
	if (sceneState.car==2 and (not sceneState.guitarFixed) and (not game.hasItem("strings",2))) then
        print("inside")
		hintItem = scene_members.carSprite3
		return
	end
	
	if (game.hasItem("knife")) then
		hintItem = scene_members.heartGhostSprite
		return
	end
	
	if (game.hasItem("strings",4)) then
		hintItem = scene_members.guitarGhostSprite
		return
	end
	
	if (sceneState.showGhost and sceneState.slide3 ~= 1) then
		hintItem = scene_members.slide3
		return
	end
	
	if (game.hasItem("ladder")) then
		hintItem = scene_members.balconyGhostSprite
		return
	end
	
	if (game.hasItem("candle") and sceneState.ladderSet) then
		hintItem = scene_members.balconyGhostSprite
		return
	end
	
	if (sceneState.candleLightSet and sceneState.collegeticket ~= 1) then
		hintItem = scene_members.collegeticket
		return
	end

	if (game.hasItem("lighter") and sceneState.candleSet and not sceneState.candleLightSet) then
		hintItem = scene_members.balconyGhostSprite
		return
	end
	
	game.addExit(scene_members.doorhint)
	game.addExit(scene_members.exit)
	
	--[[
	 
	 если струна1 не взята
	 	-постамент
	 end
	 
	 если есть ключ
	 	- багажник
	 end
	 
	 если есть домкрат
	 	- машина
	 end
	 
	 если машина поддомкрачена, но не взята струна2
	 	- под машину
	 end
	 
	 если есть нож
	 	- сердце
	 end
	 
	 если показан призрак, но не взят слайд
	 	- слайд
	 end
	 
	 если есть лестница
	 	- место для лестницы
	 end
	 
	 если есть свеча и зажигалка
	 	- на фонарик
	 end
	 
	 на дверь
	 
	 ]]
	
end


-- обновение экрана после каких-то действий
function updateScreen()
    
    print("update")
	-- switch off guitar ghost & button
	scene_members.guitarGhostSprite:setVisible(sceneState.guitarFixed == 0)
	
    -- switchoff all cars and ghosts
    for cur = 1, 3 do
        scene_members["carSprite"..cur]:setVisible(false)
    end
    scene_members.carGhostSprite1:setVisible(false)
    scene_members.carGhostSprite2:setVisible(false)
    
    -- if car is normal
    if sceneState.car == 0 then
        scene_members.carSprite1:setVisible(true)
        scene_members.carGhostSprite1:setVisible(true)
    end
	
    -- junk is open
    if sceneState.car == 1 then
        scene_members.carSprite2:setVisible(true)
        scene_members.carGhostSprite2:setVisible(true)
    end
	
    --car jacked
    if sceneState.car == 2 then
        scene_members.carSprite3:setVisible(true)
    end
    
    scene_members.pedestalGhostSprite:setVisible(not (sceneState.string1 == 1))
	
	-- heart
    scene_members.heartSprite:setVisible(sceneState.heartComplete == 4)
    scene_members.heartGhostSprite:setVisible(sceneState.heartComplete < 4)
    
	-- ghost ccbutton
	--core.enables(scene_members.ghostButton, sceneState.heartComplete == 4)
	scene_members.heartGhostSprite:setVisible(not (sceneState.heartComplete == 4))
	
	-- switch off slide
	if scene_members.slide3 then
		scene_members.slide3:setVisible((sceneState.slide3 ~= 1) and (sceneState.heartComplete == 4) and sceneState.guitarFixed)
	end
	
	-- guitar
	scene_members.guitarGhostSprite:setVisible(not sceneState.guitarFixed)
	
	-- balcony
	scene_members.balconyGhostSprite:setVisible(not sceneState.candleLightSet)
	scene_members.evilSprite:setVisible(not sceneState.candleLightSet)

	--ticket
	--scene_members.collegeticket:setVisible(sceneState.candleLightSet)
	
	scene_members.ladderSprite:setVisible(sceneState.ladderSet)
	
end


function showGhost()
	-- run ghost
	scene_members.manGhostSprite:setVisible(true)
	game.restartParticles(scene_members.explosionParticles)
	sceneState.slide3 = 0
    sceneState.showGhost = true
    showDescription(LOCALIZE("S10_GHOST"),2)
end

local function openCar()
    sceneState.car = 1
    
    effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0090_trunk.mp3"))
    updateScreen()
	game.removeItem("carkey")
    showDescription(LOCALIZE("S10_UNDERCAR"))
end

local function jackCar()
    sceneState.car = 2
    updateScreen()
	game.removeItem("carjack")
    showDescription(LOCALIZE("S10_CARPULLED"))
    effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0091_carjack.mp3"))
end

local function checkGhost()
	if (sceneState.heartComplete == 4) and sceneState.guitarFixed then
		showGhost()
	end
	
	updateScreen()
end

local function useKnife()
	-- show knife
	sceneState.heartComplete = sceneState.heartComplete + 1
	
    effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0093_carve1.mp3"))
	local x, y = scene_members["knifeArea"..sceneState.heartComplete]:getPosition()
	scene_members.knifeSprite:setVisible(true)
	scene_members.knifeSprite:setPosition(ccp(x,y))
	
	scene_members.slicesParticles:setPosition(ccp(x,y))
	scene_members.slicesParticles:setVisible(true)
	game.restartParticles(scene_members.slicesParticles)
	
	game.pickAnimation(scene_members.knifeSprite,nil)
	
	scene_members["heartSprite"..sceneState.heartComplete]:setVisible(true)
	scene_members["heartSprite"..sceneState.heartComplete]:runAction(CCFadeIn:create(0.2))
	
	
	if sceneState.heartComplete == 4 then
		checkGhost()
		game.closeSubSceneInTime(1)
		game.removeItem("knife")
	end
	
	
end

local function fixGuitar()
	scene_members.stringsSprite:setVisible(true)
	sceneState.guitarFixed = true
    effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0095_guitarstrum.mp3"))
    showDescription(LOCALIZE("S10_GUITARFULL"),2)
	game.closeSubSceneInTime(1)
	checkGhost()
    game.removeItem("strings",4)
end

local function setupLadder()
	scene_members.ladderSprite:setVisible(true)
	scene_members.ladderSprite:runAction(CCFadeIn:create(0.2))
	sceneState.ladderSet = true
	updateScreen()
	game.removeItem("ladder")
end

local function setupCandle()
	sceneState.candleSet = true
	scene_members.candleSprite:runAction(CCFadeIn:create(0.2))
	scene_members.candleSprite:setVisible(true)
showDescription(LOCALIZE("S10_CANDLESET"))
	game.removeItem("candle")
end

local function lightCandle()
	if(sceneState.candleLightSet)then
		return
	end
	sceneState.candleLightSet = true
	scene_members.lightSprite:setVisible(true)
	scene_members.candleParticles:setVisible(true)
	scene_members.collegeticket:setVisible(true)
	print("light",gameState.lighterUsages)
	gameState.lighterUsages = gameState.lighterUsages - 1
		if (gameState.lighterUsages == 0) then
		game.removeItem("lighter")
	end
    showDescription(LOCALIZE("S5_GHOSTAWAY"),2)
	updateScreen()
	game.closeSubSceneInTime(1)

end

-- использован предмет инвентаря
function inventoryItemUsed(it, x, y, action, sender)
    
    --    if (it == "hammer" and action == 64) then
	if (action == 64) then
        
        if it == "carkey" then
            game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.carSprite1,openCar, 64)
        end
        
        if it == "carjack" then
            game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.carSprite2,jackCar, 64)
        end
        
		if it == "ladder" then
            game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.balconyGhostSprite,setupLadder, 64)
        end
		
        if it == "knife" then
			local number = sceneState.heartComplete + 1
			local nextThing = "knifeArea"..number
            game.enablesItemfromInventory(x,y,scene_members[nextThing],useKnife, 64)
        end
		
		if it == "candle" then
			game.enablesItemfromInventory(x,y,scene_members.candleSprite,setupCandle, 64)
		end
		
		if it == "lighter" then
			if sceneState.candleSet then
				game.enablesItemfromInventory(x,y,scene_members.candleSprite,lightCandle, 64)
				else
				--showDescription("Мне нужна свеча...",2)
			end
		end
		if it == "strings" then
            game.enablesItemfromInventory(x,y,scene_members.stringsSprite,fixGuitar, 64)
        end
		
        --game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.boardGhostSprite,showGhost, 64)
        
        --if it == "slide1" or it == "slide2" or it == "slide3" or it == "slide4" or it == "slide5" then
		
        --    game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.projectorGhostSprite,addSlide,action)
		
        --end
        
    end
end

-- призрак
function scene_selectors.ghostPressed(sender)
    if sceneState.showGhost then
        showDescription(LOCALIZE("S10_GHOST"),2)
    end
	--
end

-- балкон
function scene_selectors.balconyPressed(sender)
    if(sceneState.candleLightSet) then
        return -- mantis 0000391
    end
	if not sceneState.ladderSet then
		showDescription(LOCALIZE("S10_SHADOW"),2)
		else
		game.initSubScene("scene_10_6", "balconyWindow")
        if(sceneState.candleSet)then
            showDescription(LOCALIZE("S10_CANDLESET"))
        else
            showDescription(LOCALIZE("S5_CAMINGHOST"))
        end
		scene_members.candleSprite:setVisible(sceneState.candleSet)
	end
	--
end

-- гитара
function scene_selectors.guitarPressed(sender)
	if not sceneState.guitarFixed then
        game.initSubScene("scene_10_5", "guitarWindow")
        showDescription(LOCALIZE("S10_GUITARNOTSTRINGS"))
        scene_members.stringsSprite:setVisible(sceneState.guitarFixed)
    end
end

-- машина
function scene_selectors.carPressed(sender)
    print("car pressed")
    if sceneState.car == 0 then
        showDescription(LOCALIZE("S10_CARCLOSED"),2)
    end
    if sceneState.car == 1 then
        game.initSubScene("scene_10_2", "junkWindow")
        scene_members.carjack:setVisible(sceneState.carjack == 0)
        showDescription(LOCALIZE("S10_CAROPEN"))
    end
    
    if (sceneState.car == 2) and (not (sceneState.string2 == 1)) then
        game.initSubScene("scene_10_1", "carWindow")
    end
end

-- пьедестал
function scene_selectors.pedestalPressed(sender)
	if not (sceneState.string1 == 1) then
        game.initSubScene("scene_10_3", "pedestalWindow")
    end
end

-- сердце
function scene_selectors.heartPressed(sender)
    print("heart")
    if (sceneState.heartComplete < 4) then
        game.initSubScene("scene_10_4", "heartWindow")
		showDescription(LOCALIZE("S10_TREE"))
        --[[core.createSkipButton(function()
                              game.closeSubScene()
                              sceneState.heartComplete = 4
                              game.removeItem("knife")
                              updateScreen()
                              event()
                              end)]]
		if sceneState.heartComplete > 0 then
			-- set visible current part
			scene_members["heartSprite"..sceneState.heartComplete]:setVisible(true)
		end
		
    end
end



function scene_selectors.entrancePressed(sender)
    game.startSceneWithSaveState("scene_11", "11_corridor", true);
end

function scene_selectors.exitPressed(sender)
	if (gameState.exitActive == false) then
		return
	end

    game.startSceneWithSaveState("scene_8", "08_college", true);
end

-- апдейт при входе на сцену
function event()
	
    -- showGhost
    scene_members.carButton:setVisible(not (sceneState.string2 == 1))
 	scene_members.manGhostSprite:setVisible((sceneState.heartComplete == 4) and sceneState.guitarFixed)
    if((sceneState.heartComplete == 4) and sceneState.guitarFixed) then
        if(tmp.ghost == nil) then
            --showDescription(LOCALIZE("S10_GHOST"),2)
            effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0024_actionok.mp3"))
            tmp.ghost = 1
        end
    end
    
	updateScreen()
	
end
