-- autostart
-- core.*
-- scene_selectors
-- scene_members

sceneState = gameState.scene11


-- показывать ли призрака
if sceneState.showGhost == nil then
    sceneState.showGhost = false
end

-- открыта ли вентиляция
if sceneState.ventOpen == nil then
	sceneState.ventOpen = 0
end

-- включен ли свет
if sceneState.lightOn == nil then
	sceneState.lightOn = false
end

-- включен ли свет
if sceneState.rosePlaced == nil then
	sceneState.rosePlaced = false
end


if not sceneState.screwdriver then
	sceneState.screwdriver = 0
end

if sceneState.screw1 == nil then
	sceneState.screw1 = false
end
if sceneState.screw2 == nil then
	sceneState.screw2 = false
end



function showCurrentHint()
    
	if (sceneState.lightOn == false) then
		core.CCLOG("1")
        --EOSA - 71
        hintItem = scene_members.testhint
		--hintItem = scene_members.electrohint
		return
	else
		if (sceneState.ventOpen == 0) then
			if (game.hasItem("screwdriver")) then
				hintItem = scene_members.venthint
				return
			else
				hintItem = scene_members.boxhint
				return
			end
		else
			if (sceneState.string3 ~= 1 or sceneState.chalk ~= 1) then
				hintItem = scene_members.venthint
				return
			end
		end

		if (sceneState.rosePlaced == false) then
			if (game.hasItem("rose")) then
				hintItem = scene_members.carpetGhostSprite
				return
			end
		else
			if (sceneState.showGhost and (sceneState.slide4 ~= 1)) then
				hintItem = scene_members.slide4
				return
			end
		end
		
	end
	
	if (sceneState.showGhost) then
		game.addExit(scene_members.doorhint)
	end
	
	game.addExit(scene_members.exit)
	
	--[[
	 если свет не включен
	 	- головоломка
	 иначе
	 	если не откручено
	 		если есть отвертка
	 			- решетка
	 		иначе
	 			- ящик
	 		end
	 	иначе
	 		если нет струны
	 			- дырка
	 		end
	 	end
	 
	 	если дверь закрыта
	 		если есть роза
	 			- коврик
	 		иначе
	 			- выход
	 		end
	 	иначе
	 		если слайд не взят
	 			-слайд
	 		end
	 
	 		- вход
	 	end
	 
	 end
	 
	 - выход
	 
	 ]]
	
end


-- обновение экрана после каких-то действий
function updateScreen()
    
    print("update")
    
    -- vent hole
    scene_members.ventClosedGhostSprite:setVisible(sceneState.ventOpen == 0)
    scene_members.ventOpenGhostSprite:setVisible((sceneState.ventOpen == 1) and ((not sceneState.chalk) or (not sceneState.string3)))
    --
	scene_members.openVentSprite:setVisible(sceneState.ventOpen == 1)
    
    --
    scene_members.boardGhostSprite:setVisible(not sceneState.lightOn)
    scene_members.electroGhostSprite:setVisible(not sceneState.lightOn)
    scene_members.boxGhostSprite:setVisible(sceneState.screwdriver == 0 and sceneState.lightOn)
    
    scene_members.carpetGhostSprite:setVisible(sceneState.lightOn and (not sceneState.rosePlaced))
    
    scene_members.doorSprite:setVisible(sceneState.rosePlaced)
    
    
    
    scene_members.darkSprite:setVisible(not sceneState.lightOn)
    scene_members.lightSprite:setVisible(sceneState.lightOn)
    scene_members.electroSprite:setVisible(sceneState.lightOn)
    
    -- switch off slide
    if sceneState.slide4 == 0 then
        scene_members.slide4:setVisible( true )
    end

    
end


function showGhost()
	-- run ghost
	scene_members.manGhostSprite:setVisible(true)
	game.restartParticles(scene_members.explosionParticles)
	showDescription(LOCALIZE("S11_GHOST"))
    sceneState.showGhost = true
end

local function checkScrews()
    if sceneState.screw1 and sceneState.screw2 then
        game.closeSubSceneInTime(1)
        sceneState.ventOpen = 1
        game.removeItem("screwdriver")
        updateScreen()
        effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0089_smallcabinet.mp3"))
        showDescription(LOCALIZE("S11_GRIDOEN"))
    end
end

local function openScrew1()
    print("screw1")
    if(sceneState.screw1)then
        return
    end
    sceneState.screw1 = true
	
    effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0084_screwdriver.mp3"))
	x, y = scene_members.screwArea1:getPosition()
	scene_members.screwdriverSprite:setVisible(true)
	scene_members.screwdriverSprite:setPosition(ccp(x,y))

	game.pickAnimation(scene_members.screwdriverSprite,nil)
	
    scene_members.screwSprite1:runAction(CCFadeOut:create(1))
	checkScrews()
end

local function openScrew2()
    print("screw2")
    if(sceneState.screw2)then
        return
    end
    sceneState.screw2 = true
	effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0084_screwdriver.mp3"))
	x, y = scene_members.screwArea2:getPosition()
	scene_members.screwdriverSprite:setVisible(true)
	scene_members.screwdriverSprite:setPosition(ccp(x,y))
    
	game.pickAnimation(scene_members.screwdriverSprite,nil)
    scene_members.screwSprite2:runAction(CCFadeOut:create(1))
	checkScrews()
end

local function openDoor()
    sceneState.rosePlaced = true
    scene_members.roseSprite:setVisible(sceneState.rosePlaced)
    showGhost()
    sceneState.slide4 = 0
	game.removeItem("rose")
    updateScreen()
	
end

-- использован предмет инвентаря
function inventoryItemUsed(it, x, y, action, sender)
    
	if (action == CC_RELEASE_OUTSIDE) then
        
        if it == "screwdriver" then
            game.enablesItemfromInventory(x,y,scene_members.screwArea1,openScrew1, 64)
            game.enablesItemfromInventory(x,y,scene_members.screwArea2,openScrew2, 64)
        end
        
        if it == "rose" then
            game.enablesItemfromInventory(x,y+GAME_INVENTORY_ITEM_SHIFT_POSITION,scene_members.roseGhostSprite,openDoor, 64)
            
        end
    end
end

local function moveKnob(number, difY)
    local xx, yy = scene_members["knob"..number]:getPosition()
    yy = yy + difY
    scene_members["knob"..number]:setPosition(ccp(xx,yy))
    
    if number == 1 then
        xx, yy = scene_members.knob2:getPosition()
        yy = yy - (difY/4)
        scene_members.knob2:setPosition(ccp(xx,yy))
    end
    
    if number == 2 then
        xx, yy = scene_members.knob3:getPosition()
        yy = yy + (difY/2)
        scene_members.knob3:setPosition(ccp(xx,yy))
    end
   
    if number == 3 then
        xx, yy = scene_members.knob4:getPosition()
        yy = yy - ((difY/2)*3)
        scene_members.knob4:setPosition(ccp(xx,yy))
    end
    
    if number == 4 then
        xx, yy = scene_members.knob1:getPosition()
        yy = yy + difY
        scene_members.knob1:setPosition(ccp(xx,yy))
    end
    
end
local result = 0
local lighsCoords = {190,90,215,240}
local function checkLights()
    
    result = 0
    
    for cur = 1, 4 do
        x, y = scene_members["knob"..cur]:getPosition()
        local dif = math.abs(y - lighsCoords[cur])
        scene_members["greenSprite"..cur]:setVisible(dif < 10)
        scene_members["redSprite"..cur]:setVisible(not(dif < 10))
        if dif < 10 then
            result = result + 1
        end
    end
    
end

-- мини-игра
function scene_selectors.knobUsed(sender, action)
    local x,y = core.getLastTouchLocation(sender)
    -- define lower left point
    --local bb_x,bb_y =  scene_members.activeArea:getPosition()
	--local size = scene_members.activeArea:getContentSize()
	--local bb_y = bb_y - size.height/2
    -- get inner coords
    --y = y - bb_y
    
    local knobNumber = sender:getTag()
    
    local sparks = scene_members.sparksParticles
    tolua.cast(sparks, "CCParticleSystemQuad")
    local xx,yy = sender:getPosition()
    
    if action == CC_TOUCH then
        -- previous press
        effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0086_electr1.mp3"))
        prevY = y
        -- particles
        sparks:setDuration(-1)
        sparks:setVisible(true)
        game.restartParticles(scene_members.sparksParticles)
    end
    

    
    if action == CC_DRAG_INSIDE or action == CC_DRAG_OUTSIDE then
        local difY = y - prevY
        moveKnob(knobNumber, difY)
        prevY = y
    end

    -- cut y
    for cur = 1, 4 do
        local x,y = scene_members["knob"..cur]:getPosition()
        if y > 290 then
            y = 290
        end
        if (y < 90) then
            y = 90
        end
        scene_members["knob"..cur]:setPosition(ccp(x,y))
        if cur == knobNumber then
            sparks:setPosition(ccp(x,y))
        end
    end
    
    checkLights()
    
    if action == CC_RELEASE_INSIDE or action == CC_RELEASE_OUTSIDE then
        effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0086_electr1.mp3"))
        sparks:setDuration(0.5)
        if result == 4 then
            game.closeSubSceneInTime(1)
            effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0110_activatespotlight.mp3"))
            sceneState.lightOn = true
            updateScreen()
        end
    end

end

-- призрак
function scene_selectors.doorPressed(sender)
    if sceneState.rosePlaced then
        game.startSceneWithSaveState("scene_12", "12_dorm", true); 
        effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0025_navigate.mp3"))
    end
	--
end

-- призрак
function scene_selectors.ghostPressed(sender)
    if sceneState.showGhost then
        showDescription(LOCALIZE("S11_GHOST"),2)
    end
	--
end

function scene_selectors.electroPressed(sender)
    if not sceneState.lightOn then
        showDescription(LOCALIZE("S11_ELECTROBOX"))
        game.initSubScene("scene_11_2", "electroWindow")
        checkLights()
        
        core.createSkipButton(function()
                                game.closeSubScene()
                                  sceneState.lightOn = true
                                  updateScreen()
                              end)
    end
	--
end

function scene_selectors.carpetPressed(sender)
    if(sceneState.lightOn)then
        if not sceneState.rosePlaced then
            showDescription("Здесь чего-то не хватает...")
            game.initSubScene("scene_11_6", "carpetWindow")
        end
    end
	--
end

function scene_selectors.ventPressed(sender)
    if sceneState.ventOpen == 0 then
        game.initSubScene("scene_11_4", "gridWindow",nil,function()scene_members.screwArea1 = nil  scene_members.screwArea2 = nil end)
        showDescription(LOCALIZE("S11_GRID"))
        scene_members.screwSprite1:setVisible(not sceneState.screw1)
        scene_members.screwSprite2:setVisible(not sceneState.screw2)
    end
    
    
    if sceneState.ventOpen == 1 then
        --sc.node:removeFromParentAndCleanup(true);
        game.initSubScene("scene_11_5", "ventWindow")
        if sceneState.string3 == 1 then
            scene_members.string3:removeFromParentAndCleanup(true);
        end
        
        if sceneState.chalk == 1 then
            scene_members.chalk:removeFromParentAndCleanup(true);
        end
        
    end
	--
end

function scene_selectors.boardPressed(sender)
    if not sceneState.lightOn then
        showDescription(LOCALIZE("S11_ELECTROMAP"))
        game.initSubScene("scene_11_1", "boardWindow")
    end
	--
end

function scene_selectors.boxPressed(sender)
    if sceneState.lightOn then
        game.initSubScene("scene_11_3", "boxWindow")
        print("scew",scene_members.screwdriver)
        scene_members.screwdriver:setVisible(sceneState.screwdriver == 0)
    end
	--
    --
end



function scene_selectors.exitPressed(sender)
	if (gameState.exitActive == false) then
		return
	end

    game.startSceneWithSaveState("scene_10", "10_yard", true);
end

-- апдейт при входе на сцену
function event()
    -- showGhost
    scene_members.roseSprite:setVisible(sceneState.rosePlaced)
 	scene_members.manGhostSprite:setVisible(sceneState.showGhost)
    
    if sceneState.slide4 == 1 then
        scene_members.slide4:removeFromParentAndCleanup(true);
    end
    
	updateScreen()
	
end
