-- autostart
-- core.*
-- scene_selectors
-- scene_members

sceneState = gameState.scene12


-- показывать ли призрака
if sceneState.showGhost == nil then
    sceneState.showGhost = false
end

-- включен ли свет
if sceneState.keyboardSet == nil then
    sceneState.keyboardSet = false
end

-- включен ли хог
if sceneState.hogIsOn == nil then
	sceneState.hogIsOn = true
end


function showCurrentHint()
	if (sceneState.hogIsOn) then
		hintItem = scene_members.hoghint
		return
	end
	
	if (sceneState.string4 ~= 1) then
		hintItem = scene_members.pillowGhostSprite
		return
	end
	
	if (sceneState.dlever ~= 1) then
		hintItem = scene_members.binGhostSprite
		return
	end
	
	if (sceneState.keyboardSet == false) then
		if (game.hasItem("keyboard")) then
			hintItem = scene_members.tableGhostSprite
			return
		end
	else
		if (sceneState.slide5 == 0) then
			hintItem = scene_members.slide5
			return
		end
	end
	
	hintItem = scene_members.exit
	
	--[[
	
	 если активен хог
	 	- хог
	 end
	 
	 если не взята струна4
	 	- подушка
	 end
	 
	 если не взят dlever
	 	- корзина
	 end
	 
	 если не установлена клавиатура
	 	если клавиатура есть
	 		- стол
	 	end
	 иначе
	 	если слайд не взят
	 		-слайд
	 	end
	 end
	 
	 - выход
	 
	]]
	
	
end

-- обновение экрана после каких-то действий
function updateScreen()

    -- vent hole
    scene_members.pillowGhostSprite:setVisible(not (sceneState.string4 == 1))
    scene_members.binGhostSprite:setVisible(not (sceneState.dlever == 1))
    scene_members.tableGhostSprite:setVisible(not sceneState.keyboardSet)

    scene_members.keyboardSprite:setVisible(sceneState.keyboardSet)
    
    scene_members.hogParticles:setVisible(sceneState.hogIsOn)
    scene_members.hogButton:setEnabled(sceneState.hogIsOn)

    -- switch off slide
    if sceneState.slide5 == 0 then
        scene_members.slide5:setVisible( true )
    end

end


function showGhost()
    -- run ghost
    scene_members.manGhostSprite:setVisible(true)
    game.restartParticles(scene_members.explosionParticles)
    effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0024_actionok.mp3"))
    sceneState.showGhost = true
    sceneState.slide5 = 0
    showDescription(LOCALIZE("S12_GHOST"),2)
end

local function setupKeyboard()
    sceneState.keyboardSet = true
    effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0003_click.mp3"))
    showGhost()
    updateScreen()
	game.removeItem("keyboard")
end

-- использован предмет инвентаря
function inventoryItemUsed(it, x, y, action, sender)

    if (action == CC_RELEASE_OUTSIDE) then

        if it == "keyboard" then
            game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.tableButton,setupKeyboard, 64)
        end
    end
end

function scene_selectors.hogPressed(sender)
    -- hog start here
    local m = scene_members;
    local gs = gameState.scene12;
    
    game.startSubScene("scene_10hog", m.minigames, scene_members.sceneMenu)
	
    sceneHOGNum = 12;
	
    game.initCommonHog(scene12)
	-- _G[]
end

function scene_selectors.tablePressed(sender)
    if not  sceneState.showGhost then
        showDescription(LOCALIZE("S12_KEYBOARD"),2)
    end
    --
end

-- призрак
function scene_selectors.ghostPressed(sender)
    if sceneState.showGhost then
            showDescription(LOCALIZE("S12_GHOST"),2)
    end
--
end


function scene_selectors.binPressed(sender)
    if not (sceneState.dlever == 1) then
            showDescription("Здесь что-то есть...")
            game.initSubScene("scene_12_1", "binWindow")
    end
end

function scene_selectors.pillowPressed(sender)
    if not (sceneState.string4 == 1) then
        game.initSubScene("scene_12_2", "pillowWindow")
    end
end




function scene_selectors.exitPressed(sender)
	if (gameState.exitActive == false) then
		return
	end
	
    game.startSceneWithSaveState("scene_11", "11_corridor", true);
end

-- апдейт при входе на сцену
function event()
-- showGhost

	scene_members.manGhostSprite:setVisible(sceneState.showGhost)

	if sceneState.slide5 == 1 then
		scene_members.slide5:removeFromParentAndCleanup(true);
	end
	
	updateScreen()
    
end

--описание на сцене
function onTouchLayer(eventType, x, y)
print("working")
    if eventType == CCTOUCHBEGAN then
        print(x,y)
        game.doActionOnScene(x,y,scene_members.monitorDescription,function()
            if(not sceneState.showGhost) then
            showDescription(LOCALIZE("S12_MONITOR"),2)
            end
        end)

    end
end
