-- autostart
-- core.*
-- scene_selectors
-- scene_members
sceneState = gameState.scene13


if not sceneState.redwire then
	sceneState.redwire = 0
end

if not sceneState.pliers then
	sceneState.pliers = 0
end

if not sceneState.fence then
	sceneState.fence = 0
end

if not sceneState.ghost then
	sceneState.ghost = 0
end

if not sceneState.addScissors then
	sceneState.addScissors = 0
end

if not sceneState.file1 then
	sceneState.file1 = 1
end

if not sceneState.firstStart then
	sceneState.firstStart = 1
    core.sendFlurryEvent("Level_<Level04>_Start")
end

-- включен ли хог
if sceneState.hogIsOn == nil then
	sceneState.hogIsOn = false
end

function showCurrentHint()
   
	if (sceneState.hogIsOn) then
		hintItem = scene_members.hoghint
		return
	end
	
	if (sceneState.redwire ~= 1) then
		hintItem = scene_members.lamphint
		return
	end
	
	if (sceneState.pliers ~= 1) then
		hintItem = scene_members.boxhint
		return
	end
	
	if (sceneState.fence == 0 and game.hasItem("pliers")) then
		hintItem = scene_members.gateshint
		return
	end
	
	if (game.hasItem("basketball")) then
		hintItem = scene_members.baskethint
		return
	end
	
	if (sceneState.ghost == 1 and sceneState.file1 ~= 1) then
		hintItem = scene_members.file1
		return
	end
	
	if (sceneState.fence == 1) then
		game.addExit(scene_members.gateshint)
	end
	game.addExit(scene_members.doorhint)
	
end
    
    
effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/amb/a_1006_windlowpitch1.mp3"))
function showGhost()
	-- run ghost
	scene_members.manGhostSprite:setVisible(true)
	scene_members.manParticles:setVisible(true)
	game.restartParticles(scene_members.explosionParticles)
	scene_members.basketGhostSprite:setVisible(false)
	game.removeItem("basketball")
	sceneState.ghost = 1
	sceneState.file1 = 0
	scene_members.file1:setVisible(sceneState.file1 == 0)
	scene_members.file1:setTouchEnabled(sceneState.file1 == 0)
    showDescription(LOCALIZE("S13_GHOSTBASCKETBALL"),2)

	
end

function scene_selectors.exitPressed(sender)
	if (gameState.exitActive == false) then
		return
	end
	
	game.startSceneWithSaveState("scene_2", "02_crossroad", true);  
end

function scene_selectors.toolboxPressed(sender)
	game.initSubScene("scene_13_1","toolBoxLayer")
	scene_members.pliers:setVisible(sceneState.pliers == 0)
	scene_members.pliers:setTouchEnabled(sceneState.pliers == 0)
end

function scene_selectors.lampPressed(sender)
	game.initSubScene("scene_13_0","lamp")
	scene_members.redwire:setVisible(sceneState.redwire == 0)
	scene_members.redwire:setTouchEnabled(sceneState.redwire == 0)
end

local function cutTheFence()
	scene_members.fenceWhole:runAction(CCFadeTo:create(0.3,0))
	sceneState.fence = 1
    showDescription(LOCALIZE("S13_CUTFENCE"))
	game.removeItem("pliers")
	event()
end

function inventoryItemUsed(it, x, y, action, sender)
	print("item used: ", it, x, y, action, sender)
	if(it == "pliers") then
		game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.fenceWhole,cutTheFence,action)
	end
	if(it == "basketball") then
		game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.basketGhostSprite,showGhost,action)
	end
end

function scene_selectors.towerPressed(sender)
    showDescription(LOCALIZE("S13_FENCE"))
    if(sceneState.fence == 1)then
        game.startSceneWithSaveState("scene_14", "14_tower", true);
    end
end



function scene_selectors.penitrationaryDoorPressed(sender)
    effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0025_navigate.mp3"))
	game.startSceneWithSaveState("scene_15", "15_penetrationary", true);
end


function scene_selectors.hogPressed(sender)
	game.startSubScene("hog_12", scene_members.minigames, scene_members.sceneMenu)
    sceneHOGNum = 13;
    game.initCommonHog(scene13)
	
end

function onTouchLayer(eventType, x, y)
    print("working")
    if eventType == CCTOUCHBEGAN then
        print(x,y)
        game.doActionOnScene(x,y,scene_members.basketGhostSprite,function()
                             showDescription(LOCALIZE("S13_BASCKET"),2)
                             end)
        game.doActionOnScene(x,y,scene_members.manGhostSprite,function()
                            if(sceneState.ghost == 1) then
                            showDescription(LOCALIZE("S13_GHOSTBASCKETBALL"),2)
                            end
                            end)
    end
end




function updateScreen()
	--[[if(sceneState.addScissors == 0) then
		if(game.hasItem("scissors"))then
			game.removeItem("scissors")
			game.addItem("scissors")
			sceneState.addScissors = 1
		end
	end]]
	scene_members.hogParticles:setVisible(sceneState.hogIsOn == true)
    scene_members.hogButton:setEnabled(sceneState.hogIsOn)
	scene_members.towerSpotlight:setVisible(gameState.scene14.redWireSet == 1)
    --[[if(sceneState.hogIsOn == true and sceneState.bench = nil) then
        showDescription(LOCALIZE("S13_BENCHDESCRIPTION"))
        sceneState.bench = 1
    end]]


	scene_members.fenceWhole:setVisible(sceneState.fence == 0)

	--scene_members.lampButton:setVisible(sceneState.redwire == 0)
	scene_members.lampGhostSprite:setVisible(sceneState.redwire == 0)


	scene_members.toolboxButton:setVisible(sceneState.pliers == 0)
	scene_members.toolBoxGhostSprite:setVisible(sceneState.pliers == 0)

	--scene_members.towerButton:setVisible(sceneState.fence == 1)
	scene_members.fenceGhostSprite:setVisible(sceneState.fence == 0)
	
end


function event()

	updateScreen()
	
	scene_members.manGhostSprite:setVisible(sceneState.ghost == 1)
	scene_members.manParticles:setVisible(sceneState.ghost == 1)
	scene_members.explosionParticles:setVisible(sceneState.ghost == 1)
	scene_members.basketGhostSprite:setVisible(sceneState.ghost == 0)

	scene_members.file1:setVisible(sceneState.file1 == 0)
	scene_members.file1:setTouchEnabled(sceneState.file1 == 0)
    
    

	
end