-- autostart
-- core.*
-- scene_selectors
-- scene_members
sceneState = gameState.scene14

-- включен ли хог
if sceneState.hogIsOn == nil then
	sceneState.hogIsOn = true
end

if not sceneState.redWireSet then
	sceneState.redWireSet = 0
end

if not sceneState.gun then
	sceneState.gun = 1
end

if not sceneState.gunCutted then
	sceneState.gunCutted = 0
end

function showCurrentHint()
   
	if (sceneState.hogIsOn) then
		hintItem = scene_members.hoghint
		return
	end
	
	if (sceneState.gunCutted == 0 and game.hasItem("scissors")) then
		hintItem = scene_members.shotgunhint
		return
	end
	
	if (sceneState.redWireSet == 0 and game.hasItem("redwire")) then
		hintItem = scene_members.lighthint
		return
	end
	
	if (sceneState.gunCutted == 1 and sceneState.gun ~= 1) then
		hintItem = scene_members.gun
		return
	end
	
	hintItem = scene_members.exit
	
end


function scene_selectors.exitPressed(sender)
	if (gameState.exitActive == false) then
		return
	end
	
	game.startSceneWithSaveState("scene_13", "13_prison", true); 
end

function scene_selectors.newsFramePressed(sender)
	game.initSubScene("scene_14_1","newsFrame")
    showDescription(LOCALIZE("S14_TABLE"))
end

local function rotateSpot()
scene_members.placedWire = nil
	if(sceneState.redWireSet == 1) then
        showDescription(LOCALIZE("S13_BENCHDESCRIPTION"))
		scene_members.spotGost:setVisible(false)
		scene_members.spotCorrect:runAction(CCFadeTo:create(0.3,255))
		scene_members.spotIncorrect:runAction(CCSequence:createWithTwoActions(CCFadeTo:create(0.3,0), CCCallFunc:create(function()
																														scene_members.spotButton:setVisible(false)
																														scene_members.spotLight:setVisible(true)
																														end
																														)))
	end
end

function scene_selectors.spotPressed(sender)
	game.initSubScene("scene_14_0","switchBox",nil,rotateSpot)
    showDescription(LOCALIZE("S14_SWITCHBOX"))
end

local function setWire()
    if(scene_members.placedWire == nil)then return end
	scene_members.activeArea:runAction(CCFadeTo:create(0.3,0))
	scene_members.placedWire:runAction(CCSequence:createWithTwoActions(CCFadeTo:create(0.4,255), CCCallFunc:create(function()
																												   game.removeItem("redwire")
																												   gameState.scene13.hogIsOn = true
																												   sceneState.redWireSet = 1
																												   scene_members.clem1:setVisible(true)
																												   game.restartParticles(scene_members.clem1)
																												   scene_members.clem2:setVisible(true)
																												   game.restartParticles(scene_members.clem2)
																												   game.closeSubScene()
																												   end
																												   )))

	


	
end


local function cutTheShotgunRope()
	if(sceneState.gunCutted == 0)then
		scene_members.shotGunGhost:setVisible(false)
        showDescription(LOCALIZE("S14_SHOTGUNFREE"))
		scene_members.shotGunTied:runAction(CCSequence:createWithTwoActions(CCFadeTo:create(0.4,0), CCCallFunc:create(function()
																													   sceneState.gun = 0
																													  sceneState.gunCutted = 1
																													  if(gameState.scene16.paintingCutted == 1 and gameState.scene16.curtainCutted == 1 and sceneState.gunCutted == 1) then
																														game.removeItem("scissors")
																													  end
																													  scene_members.gun:setVisible(sceneState.gun == 0)
																													  scene_members.gun:setTouchEnabled(sceneState.gun == 0)
																													   updateScreen()
																													   end
																													   )))
	end
end

function inventoryItemUsed(it, x, y, action, sender)
	print("item used: ", it, x, y, action, sender)
	if(it == "redwire") then
		if(scene_members.activeArea)then
			game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.activeArea,setWire,action)
		end
	end
	if(it == "scissors") then
		game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.shotGunTied,cutTheShotgunRope,action)
	end

end



function scene_selectors.hogPressed(sender)
	game.startSubScene("hog_11", scene_members.minigames, scene_members.sceneMenu)
    sceneHOGNum = 14;
    game.initCommonHog(scene14)
end

function onTouchLayer(eventType, x, y)
    print("working")
    if eventType == CCTOUCHBEGAN then
        print(x,y)
        game.doActionOnScene(x,y,scene_members.shotGunTied,function()
										if(sceneState.gunCutted == 0)then
                                      showDescription(LOCALIZE("S14_SHOTGUN"),2)
									  end
                                                            end)
															
    end
end



function updateScreen()
	if(game.hasItem("basketball") or gameState.scene14.ghost == 1) then
		sceneState.hogIsOn = false
	end
	scene_members.hogParticles:setVisible(sceneState.hogIsOn == true)
    scene_members.hogButton:setEnabled(sceneState.hogIsOn == true)
end


function event()
	updateScreen()

	scene_members.shotGunTied:setVisible(sceneState.gunCutted == 0)
	scene_members.shotGunGhost:setVisible(sceneState.gunCutted == 0)
	scene_members.gun:setVisible(sceneState.gun == 0)
	scene_members.gun:setTouchEnabled(sceneState.gun == 0)
	
	if(sceneState.redWireSet == 1) then
		scene_members.spotGost:setVisible(false)
		scene_members.spotCorrect:setOpacity(255)
		scene_members.spotIncorrect:setVisible(false)
		scene_members.spotButton:setVisible(false)
		scene_members.spotLight:setVisible(true)
	end
end