-- autostart
-- core.*
-- scene_selectors
-- scene_members


sceneState = gameState.scene15

--забиты ли двери
if not sceneState.planks then
	sceneState.planks = 0
end

if not sceneState.openWarden then
	sceneState.openWarden = 0
end

if not sceneState.openGates then
	sceneState.openGates = 0
end

if not sceneState.glassBroken then
	sceneState.glassBroken = 0
end

if not sceneState.curtainPlaced then
	sceneState.curtainPlaced = 0
end

if not sceneState.ghost then
	sceneState.ghost = 0
end

if not sceneState.ironball then
	sceneState.ironball = 0
end

if not sceneState.file2 then
	sceneState.file2 = 1
end


function showCurrentHint()
    
	if (sceneState.ghost == 1 and sceneState.file2 ~=1) then
		hintItem = scene_members.file2
		return
	end
	
	if (sceneState.planks == 0 and game.hasItem("crowbar")) then
		hintItem = scene_members.plankshint
		return
	end
	
	if (sceneState.openWarden == 0) then
		hintItem = scene_members.combinationhint
		return
	end
	
	if (game.hasItem("shotgun",2)) then
		hintItem = scene_members.glasshint
		return
	end
	
	if (sceneState.glassBroken == 1 and game.hasItem("curtain")) then
		hintItem = scene_members.curtainhint
		return
	end
	
	if (sceneState.ghost == 0 and game.hasItem("ironball")) then
		hintItem = scene_members.ironballhint
		return
	end
	
	if (sceneState.curtainPlaced == 1) then
		if (sceneState.ironball~=1) then
			hintItem = scene_members.ironball
			return
		end
		if (sceneState.openGates == 0) then
			hintItem = scene_members.lockerhint
			return
		end
	end
	
	if (sceneState.planks == 0) then
		hintItem = scene_members.plankshint
		return
	end
	
	game.addExit(scene_members.exit)
	
	if (sceneState.openGates == 1) then
		game.addExit(scene_members.gateshint)
	end
	
	if (sceneState.planks == 1 and sceneState.openWarden == 1) then
		game.addExit(scene_members.plankshint)
	end
	
end



function scene_selectors.exitPressed(sender)
	if (gameState.exitActive == false) then
		return
	end
	
	game.startSceneWithSaveState("scene_13", "13_prison", true);  
end



function scene_selectors.cabinetButtonPressed(sender)
    
    if(sceneState.planks == 0 or sceneState.openWarden == 0) then
        showDescription(LOCALIZE("S15_DIRECTORROOM"))
        return
    end
	game.startSceneWithSaveState("scene_16", "16_cabinet", true)
end

function scene_selectors.diningRoomButtonPressed(sender)
	game.startSceneWithSaveState("scene_17", "17_diningroom", true)
end



local function opensWarden()
	--scene_members.cabinetButton:setVisible(true)
    showDescription(LOCALIZE("S15_CLEARWAY"))
    
	scene_members.openWarden:runAction(CCSequence:createWithTwoActions(CCFadeTo:create(0.5,255), CCCallFunc:create(function()
																													scene_members.wardenLight:setVisible(sceneState.openWarden == 1 and sceneState.planks == 1)
																													end
																													)))

end
local function openCameras()
	if(sceneState.openGates == 1)then
		showDescription(LOCALIZE("S15_OPENDOORDININGROOM"))
		scene_members.camerasGatesOpen:runAction(CCSequence:createWithTwoActions(CCFadeTo:create(0.5,255), CCCallFunc:create(function()
																															 scene_members.riddleLockGhost:setVisible(false)
																															 scene_members.tableLockClosed:setVisible(false)
																															 scene_members.tableLockOpen:setVisible(true)
																															 scene_members.camerasDoorLightOpen:setVisible(true)
																															 scene_members.diningRoomButton:setVisible(true)
																															 scene_members.riddleLockButton:setVisible(false)
																													   end
																													   )))
		

	end
end
function scene_selectors.riddleLockButtonPressed(sender)
	game.initSubScene("scene_15_1","riddleLock",nil,openCameras)
    showDescription(LOCALIZE("S15_RIDDLELOCK"))
    core.createSkipButton(function()
                          
                          scene_members.ringBell:setVisible(true)
                          sceneState.openGates = 1
                          game.closeSubScene()
                          end)
    
	print("task",sceneState.task)
	local function blink(target)
		local animations = CCArray:create()
		animations:addObject(CCFadeTo:create(0.5,255))
		animations:addObject(CCFadeTo:create(0.5,0))
		local seq = CCSequence:create(animations)
		tolua.cast(seq,"CCActionInterval")
		target:runAction(CCRepeatForever:create(seq))
		target:setVisible(true)
	end

	if(sceneState.task == nil) then
		sceneState.task = 1
		sceneState.slot1 = -1
		sceneState.slot2 = -1
		sceneState.slot3 = -1
	end
	
	if(sceneState.task ~=1 )then
		for cur =1, sceneState.task - 1 do
			scene_members["greenLamp"..cur]:setVisible(true)
			--blink(scene_members["greenLamp"..sceneState.task-1])
		end
	end
	local function clear()
		for cur = 1,3 do
			
			local button = sceneState["slot"..cur]
			print("button",button)
			if(button ~= -1) then
				scene_members["light"..button]:runAction(CCSequence:createWithTwoActions(CCFadeTo:create(0.4,0), CCCallFunc:create(function()
																																scene_members["light"..button]:setVisible(false)
																																end
																																)))
				
				sceneState["slot"..cur] = -1
				print("slot"..cur,sceneState["slot"..cur] )
			end
		end
	end
	local function processTask(decision)
		if(decision == true)then
			print("correct"..sceneState.task)
			clear()
			scene_members["greenLamp"..sceneState.task]:setVisible(true)
			 --blink(scene_members["greenLamp"..sceneState.task])
			sceneState.task = sceneState.task + 1
		else
			print("incorrect".. sceneState.task)
			clear()
		end
		if(sceneState.task == 4) then
			scene_members.ringBell:setVisible(true)
			sceneState.openGates = 1
			scene_members.ringBell:runAction(CCSequence:createWithTwoActions(CCDelayTime:create(0.7), CCCallFunc:create(function()
																														game.closeSubScene()
																														end
																														)))
			
		end

	end
	local function isMatch()
		if(sceneState.task == 1)then
			if(sceneState.slot1 ~= -1 and sceneState.slot2 ~= -1) then
				processTask(sceneState.slot1 + sceneState.slot2 == 7)
			end
		else
			if(sceneState.slot1 ~= -1 and sceneState.slot2 ~= -1 and sceneState.slot3 ~= -1) then
				if(sceneState.task == 2)then
					processTask(sceneState.slot1 + sceneState.slot2 - sceneState.slot3 == 10)
				else
					processTask(sceneState.slot1 * sceneState.slot2 - sceneState.slot3 == 13)
				end
			end
			
		end
	end
	function scene_selectors.ridlleButtonsSelector(sender)
		tolua.cast(sender, "CCNode")
		local tag = sender:getTag()
		print("code: ",tag)
		if((tag == sceneState.slot1) or (tag == sceneState.slot2) or (tag == sceneState.slot3)) then
			print("incorrect!")
			return
		end
		for cur = 1,3 do
		   if( sceneState["slot"..cur] == -1 ) then
			   sceneState["slot"..cur] = tag
			   print("slot"..cur,sceneState["slot"..cur] )
			   blink(scene_members["light"..tag])
			   isMatch()
			   return
		   end
		end
	end
end

function scene_selectors.combinationLockPressed(sender)
	if(sceneState.openWarden == 1)then
	return
	end
	game.initSubScene("scene_15_0","combinationLock")
    showDescription(LOCALIZE("S15_CODELOCK"))
	local digit1 = -1
	local digit2 = -1
	local digit3 = -1
	local digit4 = -1
	local function passTheCode(tag)
		if(digit1 == -1) then
			scene_members.codestar1:setOpacity(255)
            print("inside1")
            digit1 = tag
            return true
			--[[if(tag == 1)then
				print("inside1")
				digit1 = tag
				return true
				else
				scene_members.codestar1:setOpacity(0)
				digit1 = -1
			end]]
		end
		if(digit2 == -1) then
			scene_members.codestar2:setOpacity(255)
            print("inside2")
            digit2 = tag
            return true
			--[[if(tag == 9)then
				print("inside2")
				digit2 = tag
				return true
				else
				scene_members.codestar1:setOpacity(0)
				scene_members.codestar2:setOpacity(0)
				digit1 = -1
				return false
			end]]
		end
		if(digit3 == -1) then
			scene_members.codestar3:setOpacity(255)
            print("inside3")
            digit3 = tag
            return true
			--[[if(tag == 6)then
				print("inside3")
				digit3 = tag
				return true
				else
				scene_members.codestar1:setOpacity(0)
				scene_members.codestar2:setOpacity(0)
				scene_members.codestar3:setOpacity(0)
				digit1 = -1
				digit2 = -1
				digit3 = -1
				return false
			end]]
		end
		if(digit4 == -1) then
			scene_members.codestar4:setOpacity(255)
            digit4 = tag
            scene_members.codestar4:runAction(CCSequence:createWithTwoActions(CCDelayTime:create(0.5), CCCallFunc:create(function()
                                                                                                                         if(digit1 == 1 and digit2 == 9 and digit3 == 6 and digit4 == 2)then
                                                                                                                         print("inside4")
                                                                                                                         print("unlocked")
                                                                                                                         showDescription(LOCALIZE("S15_OPENDOOR"))
                                                                                                                         game.closeSubScene()
                                                                                                                         if(sceneState.planks == 1) then
                                                                                                                         opensWarden()
                                                                                                                         sceneState.openWarden = 1
                                                                                                                         
                                                                                                                         else
                                                                                                                         sceneState.openWarden = 1
                                                                                                                         end
                                                                                                                         --event()
                                                                    

                                                                                                                         return true
                                                                                                                         else
                                                                                                                         scene_members.codestar1:setOpacity(0)
                                                                                                                         scene_members.codestar2:setOpacity(0)
                                                                                                                         scene_members.codestar3:setOpacity(0)
                                                                                                                         scene_members.codestar4:setOpacity(0)
                                                                                                                         digit1 = -1
                                                                                                                         digit2 = -1
                                                                                                                         digit3 = -1
                                                                                                                         digit4 = -1
                                                                                                                         return false
                                                                                                                         end
                                                                                                                        end
                                                                                                                        )))
            
            
			--[[if(tag == 2)then
				digit4 = tag
				print("inside4")
				print("unlocked")
				showDescription(LOCALIZE("S15_OPENDOOR"))
				game.endSubScene()
				if(sceneState.planks == 1) then
					opensWarden()
					sceneState.openWarden = 1
					
					else
					sceneState.openWarden = 1
				end
				event()
				return true
				else
				scene_members.codestar1:setOpacity(0)
				scene_members.codestar2:setOpacity(0)
				scene_members.codestar3:setOpacity(0)
				scene_members.codestar4:setOpacity(0)
				digit1 = -1
				digit2 = -1
				digit3 = -1
				digit4 = -1
				return false
			end]]
		end
		
	end
	function scene_selectors.codeButtonsSelector(sender)
		tolua.cast(sender, "CCNode")
		local tag = sender:getTag()
		print("code: ",tag)
		passTheCode(tag)
	end
	
end



local function removeBoards()
	scene_members.planksGhost:setVisible(false)
	scene_members.planksDoor:runAction(CCFadeTo:create(0.3,0))
	core.runAnimation("Default Timeline",0,scene_members.crowbarRemovesBoards)
	scene_members.crowbarRemovesBoards:setVisible(true)
	game.removeItem("crowbar")
	function scene_animations.removeAllBoards()
		scene_animations.removeAllBoards = nil
		sceneState.planks = 1
		if(sceneState.openWarden == 1) then
			opensWarden()
		end
	end
end

local function fireGlass()
	if(sceneState.glassBroken == 1)then
		return
	end
	sceneState.glassBroken = 1
	game.removeItem("shotgun",2)
    showDescription(LOCALIZE("S15_SHOOT"))
	scene_members.glassGhost:setVisible(false)
	scene_members.glassBroke:setVisible(true)
	game.restartParticles(scene_members.glassBroke)
	scene_members.bullets:setVisible(true)
	game.restartParticles(scene_members.bullets)
	scene_members.glassFall:setVisible(true)
	game.restartParticles(scene_members.glassFall)
	scene_members.fullGlass:runAction(CCFadeTo:create(0.3,0))
	scene_members.glassPieces:runAction(CCFadeTo:create(0.3,255))
	scene_members.brokenGlass:runAction(CCSequence:createWithTwoActions(CCFadeTo:create(0.3,255), CCCallFunc:create(function()
																													
																													scene_members.shapeGlassGhost:setVisible(true)
																													   end
																													   )))
	
end

local function setCurtain()
	scene_members.curtainPlaced:runAction(CCFadeTo:create(0.3,255))
	scene_members.shapeGlassGhost:setVisible(false)
	sceneState.curtainPlaced = 1
    showDescription(LOCALIZE("S15_SETCURTAIN"))
	--scene_members.diningRoomButton:setVisible(sceneState.curtainPlaced == 1)
	scene_members.ironball:setTouchEnabled(sceneState.curtainPlaced == 1)
	scene_members.riddleLockButton:setVisible(sceneState.curtainPlaced == 1)
	game.removeItem("curtain")
	
end

function showGhost()
	-- run ghost
    showDescription(LOCALIZE("S15_GHOST"),2)
	scene_members.manGhostSprite:setVisible(true)
	scene_members.manParticles:setVisible(true)
	game.restartParticles(scene_members.explosionParticles)
	scene_members.shacklesGhost:setVisible(false)
	scene_members.ironBallPlaced:setVisible(true)
	game.removeItem("ironball")
	sceneState.ghost = 1
	sceneState.file2 = 0
	scene_members.file2:setVisible(sceneState.file2 == 0)
	scene_members.file2:setTouchEnabled(sceneState.file2 == 0)

end

function inventoryItemUsed(it, x, y, action, sender)
	print("item used: ", it, x, y, action, sender)
	if(it == "crowbar") then
		game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.planksDoor,removeBoards,action)
	end
	if(it == "shotgun") then
		game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.fullGlass,fireGlass,action)
	end
	if(it == "curtain") then
		if(sceneState.glassBroken == 1) then
			game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.fullGlass,setCurtain,action)
		end
	end
	if(it == "ironball") then
		game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.shacklesGhost,showGhost,action)
	end
	
end

function onTouchLayer(eventType, x, y)
    print("working")
    if eventType == CCTOUCHBEGAN then
        print(x,y)
        game.doActionOnScene(x,y,scene_members.glassGhost,function()
                             if(sceneState.glassBroken == 0) then
                                showDescription(LOCALIZE("S15_FULLGLASS"),2)
                             end
                             if(sceneState.glassBroken == 1 and sceneState.curtainPlaced ~= 1) then
                                showDescription(LOCALIZE("S15_SHOOT"),2)
                             end
                             end)
        game.doActionOnScene(x,y,scene_members.shacklesGhost,function()
                             showDescription(LOCALIZE("S15_SHACKLES"),2)
                             end)
        game.doActionOnScene(x,y,scene_members.manGhostSprite,function()
                            if(sceneState.ghost == 1) then
                            showDescription(LOCALIZE("S15_GHOST"),2)
                            end
                            end)
    end
end



function updateScreen()
end

function event()
	scene_members.planksDoor:setVisible(sceneState.planks == 0)
	scene_members.planksGhost:setVisible(sceneState.planks == 0)
	scene_members.crowbarRemovesBoards:setVisible(false)
	scene_members.combinationLock:setVisible(sceneState.openWarden == 0)
	scene_members.combinationLockGhost:setVisible(sceneState.openWarden == 0)
	scene_members.wardenLight:setVisible(sceneState.openWarden == 1 and sceneState.planks == 1)
	if(sceneState.openWarden == 1 and sceneState.planks == 1) then
		scene_members.openWarden:setOpacity(255)
		--scene_members.cabinetButton:setVisible(true)
	end
	scene_members.ironball:setTouchEnabled(sceneState.curtainPlaced == 1)
	if(sceneState.ironball == 1)then
		scene_members.ironball:removeFromParentAndCleanup(true)
	end
	scene_members.ironBallPlaced:setVisible(sceneState.ghost == 1)
	scene_members.riddleLockButton:setVisible(sceneState.curtainPlaced == 1)
	scene_members.glassGhost:setVisible(sceneState.glassBroken == 0)
	scene_members.fullGlass:setVisible(sceneState.glassBroken == 0)
	scene_members.shapeGlassGhost:setVisible(sceneState.glassBroken == 1)
	if(sceneState.glassBroken == 1 and sceneState.curtainPlaced == 1) then
		scene_members.shapeGlassGhost:setVisible(false)
	end

	if(sceneState.glassBroken == 1) then
		scene_members.brokenGlass:setOpacity(255)
	end
	if(sceneState.curtainPlaced == 1) then
		scene_members.curtainPlaced:setOpacity(255)
	end

	scene_members.file2:setVisible(sceneState.file2 == 0)
	scene_members.file2:setTouchEnabled(sceneState.file2 == 0)

	scene_members.shacklesGhost:setVisible(sceneState.ghost == 0)
	scene_members.manGhostSprite:setVisible(sceneState.ghost == 1)
	scene_members.manParticles:setVisible(sceneState.ghost == 1)
	scene_members.explosionParticles:setVisible(sceneState.ghost == 1)
	print("curtain",sceneState.curtainPlaced)

	--gates
	if(sceneState.curtainPlaced == 1)then
		scene_members.riddleLockButton:setVisible(sceneState.openGates == 0)
	end
	scene_members.riddleLockGhost:setVisible(sceneState.openGates == 0)
	scene_members.tableLockClosed:setVisible(sceneState.openGates == 0)
	scene_members.tableLockOpen:setVisible(sceneState.openGates == 1)
	scene_members.camerasDoorLightOpen:setVisible(sceneState.openGates == 1)
	scene_members.diningRoomButton:setVisible(sceneState.openGates == 1 and sceneState.curtainPlaced == 1)
	if(sceneState.openGates == 1) then
		scene_members.camerasGatesOpen:setOpacity(255)
	end



end