-- autostart
-- core.*
-- scene_selectors
-- scene_members



sceneState = gameState.scene18

if not sceneState.file6 then
	sceneState.file6 = 1
end

if not sceneState.doorOpen then
	sceneState.doorOpen = 0
end


if not sceneState.camerasDoorOpen then
	sceneState.camerasDoorOpen = 0
end

if not sceneState.ghost then
	sceneState.ghost = 0
end


if not sceneState.prisonticket then
	sceneState.prisonticket = 1
end

-- включен ли хог
if sceneState.hogIsOn == nil then
	sceneState.hogIsOn = false
end


function showCurrentHint()
    
	if (sceneState.hogIsOn) then
		hintItem = scene_members.hoghint
		return
	end
	
	if (gameState.scene19.ghost == 1 and sceneState.prisonticket~=1) then
		hintItem = scene_members.prisonticket
		return
	end

	if (sceneState.ghost == 1 and sceneState.file6 ~=1) then
		hintItem = scene_members.file6
		return
	end

	if (sceneState.ghost == 0 and game.hasItem("mop")) then
		hintItem = scene_members.stepshint
		return
	end
	
	
	if (sceneState.camerasDoorOpen == 0) then
		hintItem = scene_members.puzzlehint
		return
	end
	
	if (sceneState.doorOpen == 0 and game.hasItem("securitycard")) then
		hintItem = scene_members.securityhint
		return
	end

	game.addExit(scene_members.exit)

	if (sceneState.doorOpen == 1) then
		game.addExit(scene_members.doorhint)
	end
	
	
end

function scene_selectors.exitPressed(sender)
	if (gameState.exitActive == false) then
		return
	end
	
	game.startSceneWithSaveState("scene_17", "17_diningroom", true) 
end

function scene_selectors.hogPressed(sender)
	print("startHog")
    if(sceneState.camerasDoorOpen == 0) then
        showDescription(LOCALIZE("S18_DOORS"),2)
        return
    end
	game.startSubScene("hog_13", scene_members.minigames, scene_members.sceneMenu)
    sceneHOGNum = 18;
    game.initCommonHog(scene18)

end

local function openDoor()
scene_members.profilePicture = nil
	if(sceneState.doorOpen == 1) then
		scene_members.openExecutoryGates:runAction(CCFadeTo:create(0.2,255))
		scene_members.gatesGhost:setVisible(sceneState.doorOpen == 0)
        showDescription(LOCALIZE("S18_OPENGATES"))
		--scene_members.executionRoomButton:setVisible(sceneState.doorOpen == 1)
	end
end

local function openCamerasDoors()
	if(sceneState.camerasDoorOpen == 1) then
        showDescription(LOCALIZE("S18_OPENCAMERAS"))
		scene_members.videoCamsPointButton:setVisible(false)
		scene_members.cellsClosed:runAction(CCFadeTo:create(0.2,0))
		scene_members.mainCellClosed:runAction(CCFadeTo:create(0.2,0))
		scene_members.cellsOpen:runAction(CCFadeTo:create(0.2,255))
		scene_members.mainCellOpen:runAction(CCFadeTo:create(0.2,255))
		scene_members.cellGhost:setVisible(false)
		sceneState.hogIsOn = true
		updateScreen()
		
		--scene_members.executionRoomButton:setVisible(sceneState.doorOpen == 1)
	end
end

function scene_selectors.videoCamsPointButtonPressed(sender)
	game.initSubScene("scene_18_1","videoCameras",nil,openCamerasDoors)
    showDescription(LOCALIZE("S18_LEVERS"))
    core.createSkipButton(function()
                          
                          sceneState.camerasDoorOpen = 1
                          scene_members.gateControlGhost:setVisible(sceneState.camerasDoorOpen == 0)
                          game.closeSubScene()
                          end)
	local levers = {}
	levers.lever8 = 0
	levers.lever9 = 0
	levers.lever10 = 0
	local function processLevers()
		local result = true
		for cur = 8, 10 do
			if(levers["lever"..cur] == 0) then
				result = false
			end
		end
		if(result) then
			sceneState.camerasDoorOpen = 1
			scene_members.gateControlGhost:setVisible(sceneState.camerasDoorOpen == 0)
			game.closeSubScene()
		end
	end

	
	local function setLever(tag)
		local curLever = scene_members["lever"..tag]
		
		if(scene_members["lever"..tag]:isVisible())then
			scene_members["lever"..tag]:setVisible(false)
			levers["lever"..tag] = 1
		else
			scene_members["lever"..tag]:setVisible(true)
			levers["lever"..tag] = 0
		end
		processLevers()
	end
	local lever1 = 0
	local lever2 = 0
	local lever3 = 0
	function scene_selectors.camerasLeversSelector(sender)
		tolua.cast(sender, "CCNode")
		local tag = sender:getTag()
		print("code: ",tag)
		setLever(tag)
		
	end
end
function scene_selectors.cardLockButtonPressed(sender)
	showDescription(LOCALIZE("S18_LOCK"))
	game.initSubScene("scene_18_0","cardLock",nil,openDoor)
end


function scene_selectors.executionRoomButtonPressed(sender)
    if(sceneState.doorOpen ==0 )then
        showDescription(LOCALIZE("S18_EXEC"))
        return
    end
	game.startSceneWithSaveState("scene_19", "19_executionroom", true); 
end

function showGhost()
	-- run ghost
    showDescription(LOCALIZE("S18_GHOST"),2)
	scene_members.manGhostSprite:setVisible(true)
	scene_members.manParticles:setVisible(true)
	scene_members.footSteps:setVisible(false)
	game.restartParticles(scene_members.explosionParticles)
	sceneState.ghost = 1
	sceneState.file6 = 0
	scene_members.file6:setVisible(sceneState.file6 == 0)
	scene_members.file6:setTouchEnabled(sceneState.file6 == 0)
	game.removeItem("mop")

end

local function showProfile()
	scene_members.openLockPicture:runAction(CCFadeTo:create(0.2,255))
	scene_members.profilePicture:runAction(CCSequence:createWithTwoActions(CCFadeTo:create(0.2,255), CCCallFunc:create(function()
																													   sceneState.doorOpen = 1
																													   
																													   scene_members.securityGhost:setVisible(sceneState.doorOpen == 0)
																													   scene_members.cardLockButton:setVisible(sceneState.doorOpen == 0)
																													   scene_members.videoCamsPointButton:setVisible(sceneState.camerasDoorOpen == 0)
																													  game.closeSubScene()
																													   
																													  end
																													  )))
end
local function openSecurityLock()
    if(scene_members.profilePicture == nil)then return end
	sceneState.doorOpen = 1
	game.removeItem("securitycard")
	--scene_members.card:setOpacity(255)
	scene_members.card:runAction(CCFadeTo:create(0.2,255))
	
	scene_members.card:runAction(CCSequence:createWithTwoActions(CCMoveTo:create(0.7,ccp(548,467)), CCCallFunc:create(function()
																												scene_members.redGlow:setVisible(false)
																												scene_members.greenGlow:setVisible(true)
																												showProfile()
																												end
																												)))

	
	

	
end

function inventoryItemUsed(it, x, y, action, sender)
	print("item used: ", it, x, y, action, sender)
	if(it == "mop") then
		game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.footSteps,showGhost,action)
	end
	if(it == "securitycard") then
		game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.activeArea,openSecurityLock,action)
	end
	
end



function onTouchLayer(eventType, x, y)
    print("working")
    if eventType == CCTOUCHBEGAN then
        game.doActionOnScene(x,y,scene_members.prisonShadw,function()
                             if(gameState.scene19.ghost ~= 1) then
                             showDescription(LOCALIZE("S18_SHADOW"),2)
                             end
                             end)
        game.doActionOnScene(x,y,scene_members.manGhostSprite,function()
                            if(sceneState.ghost == 1) then
                            showDescription(LOCALIZE("S18_GHOST"),2)
                            end
                            end)
		game.doActionOnScene(x,y,scene_members.cellGhost,function()
                            if(sceneState.camerasDoorOpen == 0) then
							showDescription(LOCALIZE("S18_DOORS"),2)
                            end
                            end)
    end
end

function updateScreen()
	scene_members.hogParticles:setVisible(sceneState.hogIsOn == true)
    scene_members.hogButton:setEnabled(sceneState.hogIsOn)
end

function event()
	updateScreen()
    print("leverState: ",gameState.scene19.tlever)
	--gameState.scene18.prisonticket = 0
	
	--man Ghost
	scene_members.manGhostSprite:setVisible(sceneState.ghost == 1)
	scene_members.manParticles:setVisible(sceneState.ghost == 1)
	scene_members.explosionParticles:setVisible(sceneState.ghost == 1)

	--steps
	scene_members.footSteps:setVisible(sceneState.ghost == 0)

	--security
	scene_members.securityGhost:setVisible(sceneState.doorOpen == 0)
	scene_members.cardLockButton:setVisible(sceneState.doorOpen == 0)

	--nextDoor
	if( sceneState.doorOpen == 1) then
		scene_members.
		openExecutoryGates:setOpacity(255)
	end
	scene_members.gatesGhost:setVisible(sceneState.doorOpen == 0)
	--scene_members.executionRoomButton:setVisible(sceneState.doorOpen == 1)


	--cameras
	scene_members.gateControlGhost:setVisible(sceneState.camerasDoorOpen == 0)
	scene_members.videoCamsPointButton:setVisible(sceneState.camerasDoorOpen == 0)
	scene_members.cellsClosed:setVisible(sceneState.camerasDoorOpen == 0)
	scene_members.mainCellClosed:setVisible(sceneState.camerasDoorOpen == 0)
	if(sceneState.camerasDoorOpen == 1) then
		scene_members.cellsOpen:setOpacity(255)
		scene_members.mainCellOpen:setOpacity(255)
	end
	scene_members.cellGhost:setVisible(sceneState.camerasDoorOpen == 0)

	--file

	scene_members.file6:setVisible(sceneState.file6 == 0)
	scene_members.file6:setTouchEnabled(sceneState.file6 == 0)

	--ticket
	scene_members.prisonticket:setVisible(sceneState.prisonticket == 0)
	scene_members.prisonticket:setTouchEnabled(sceneState.prisonticket == 0)
	--добываем билетик проверка по 19 сцене
	if(gameState.scene19.ghost == 1)then
		scene_members.prisonShadw:setVisible(false)
		for cur = 1,4 do
			scene_members["blinkSpot"..cur]:setVisible(false)
			scene_members["spot"..cur]:setVisible(true)
		end
	end

	
end