-- autostart
-- core.*
-- scene_selectors
-- scene_members

sceneState = gameState.scene20

-- показывать ли призрака
if sceneState.showGhost == nil then
    sceneState.showGhost = false
end

-- включен ли хог
if sceneState.trapOpen == nil then
	sceneState.trapOpen = false
end

if sceneState.boardsSmashed == nil then
	sceneState.boardsSmashed = 0
end

if not sceneState.firstStart then
	sceneState.firstStart = 1
    core.sendFlurryEvent("Level_<Level05>_Start")
end

if not sceneState.demon then
	sceneState.demon = 0
end

if not sceneState.broom then
	sceneState.broom = 0
end





function showCurrentHint()
    
	if (sceneState.demon ~= 1) then
		hintItem = scene_members.demon
		return
	end
	
	if (sceneState.crosskey ~=1) then
		hintItem = scene_members.statuehint
		return
	end
	
	if (sceneState.broom ~= 1) then
		hintItem = scene_members.broom
		return
	end
	
	if (game.hasItem("wings",2)) then
		hintItem = scene_members.wingshint
		return
	end
	
	if (sceneState.showGhost == false) then
		if (game.hasItem("axe")) then
			hintItem = scene_members.boardshint
			return
		end
	else
		if (sceneState.photo1 == 0) then
			hintItem = scene_members.photo1
			return
		end
	end
	
	game.addExit(scene_members.doorhint)
	game.addExit(scene_members.exit)
	
	if (sceneState.trapOpen) then
		game.addExit(scene_members.traphint)
	end
	
end

local bgMusicPath = CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/music/m_0005_church.mp3")
-- обновение экрана после каких-то действий
function updateScreen()
	
	-- boards & ghost
	scene_members.boardsGhostSprite:setVisible(not sceneState.showGhost)
	scene_members.boardsOffLightSprite:setVisible(sceneState.showGhost)
	scene_members.boardsOnLightSprite:setVisible(not sceneState.showGhost)
	scene_members.boardsSprite:setVisible(not sceneState.showGhost)
	
	-- trap door
	scene_members.purpleLightSprite:setVisible(sceneState.trapOpen)
	scene_members.wingsSprite:setVisible(sceneState.trapOpen)
	scene_members.openSprite:setVisible(sceneState.trapOpen)
	scene_members.closeSprite:setVisible(not sceneState.trapOpen)
	scene_members.wingsGhostSprite:setVisible(not sceneState.trapOpen)
	scene_members.trapdoorGhostSprite:setVisible(not sceneState.trapOpen)
	
	-- monk
	scene_members.monkGhostSprite:setVisible(sceneState.crosskey == nil)
	
    -- switch off slide
    if sceneState.photo1 == 0 then
        scene_members.photo1:setVisible( true )
    end
	
end


function showGhost()
    -- run ghost
    scene_members.manGhostSprite:setVisible(true)
    game.restartParticles(scene_members.explosionParticles)
	
    sceneState.showGhost = true
    sceneState.photo1 = 0
end

local function smashBoards()
	scene_members.boardsParticles:setVisible(true)
	game.restartParticles(scene_members.boardsParticles)

	showGhost()
	updateScreen()
	
	sceneState.boardsSmashed = 1
	
	if (gameState.scene22.logChopped) then
		game.removeItem("axe")
	end
end

local function openTrapdoor()
	sceneState.trapOpen = true
	updateScreen()
    game.removeItem("wings",2)
end

-- использован предмет инвентаря
function inventoryItemUsed(it, x, y, action, sender)
    if (action == CC_RELEASE_OUTSIDE) then
		
        if it == "axe" then
            game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.boardsSprite,smashBoards, 64)
        end
		
        if it == "wings" then
            game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.wingsSprite,openTrapdoor, 64)
        end
    end
end


-- призрак
function scene_selectors.ghostPressed(sender)
    if sceneState.showGhost then
		showDescription(LOCALIZE("S20_FATHER"),3)
    end
	--
end

-- доски
function scene_selectors.boardsPressed(sender)
    if sceneState.boardsSmashed == 0 then
		showDescription(LOCALIZE("S20_BOARDS"),3)
    end
	--
end

function scene_selectors.monkPressed(sender)
    if not (sceneState.crosskey == 1) then
		--showDescription("Здесь что-то есть...")
		game.initSubScene("scene_20_1", "monkWindow")
    end
end

function scene_selectors.trapdoorPressed(sender)
    if sceneState.trapOpen then
        game.startSceneWithSaveState("scene_21", "21_basement", true);
    else
        showDescription(LOCALIZE("S20_TRAPDOOR"),3)
    end
end

function scene_selectors.entrancePressed(sender)
    game.startSceneWithSaveState("scene_22", "22_graveyard", true);
end

function scene_selectors.angelPressed(sender)
    if not sceneState.trapOpen then
       showDescription(LOCALIZE("S20_ANGEL"),3)
    end
end




function scene_selectors.exitPressed(sender)
	if (gameState.exitActive == false) then
		return
	end
	
    game.startSceneWithSaveState("scene_2", "02_crossroad", true);
end

-- апдейт при входе на сцену
function event()
	-- showGhost
    scene_members.demon:setVisible(sceneState.demon == 0)
    scene_members.broom:setVisible(sceneState.broom == 0)
	
	scene_members.manGhostSprite:setVisible(sceneState.showGhost)
	
	if sceneState.photo1 == 1 then
		scene_members.photo1:removeFromParentAndCleanup(true);
	end
	
	updateScreen()
	
end
