-- autostart
-- core.*
-- scene_selectors
-- scene_members

sceneState = gameState.scene21

-- показывать ли призрака
if sceneState.showGhost == nil then
    sceneState.showGhost = false
end

-- показывать ли семена
if sceneState.showSeeds == nil then
    sceneState.showSeeds = false
end

-- включен ли хог
if sceneState.hogIsOn == nil then
	sceneState.hogIsOn = true
end

if sceneState.angelState == nil then
    sceneState.angelState = 0
end

if sceneState.demonState == nil then
    sceneState.demonState = 0
end

if sceneState.bagCut == nil then
    sceneState.bagCut = 0
end

if sceneState.showEvil == nil then
    sceneState.showEvil = true
end

if not sceneState.churchticketPicked then
	sceneState.churchticketPicked = false
end

function showCurrentHint()
	
	if (sceneState.hogIsOn) then
		hintItem = scene_members.hoghint
		return
	end
	
	if (sceneState.axe ~= 1) then
		hintItem = scene_members.skelethint
		return
	end
	
	if (sceneState.seeds ~= 1) then
		if (sceneState.showSeeds) then
			hintItem = scene_members.seeds
			return
		else
			if (game.hasItem("dagger")) then
				hintItem = scene_members.baghint
				return
			end
		end
	end
	
	if (sceneState.angelState == 0) then
		if (game.hasItem("angel")) then
			hintItem = scene_members.angelhint
			return
		end
	end
	if (sceneState.angelState == 1) then
		hintItem = scene_members.angelhint
		return
	end
	if (sceneState.angelState == 2 and game.hasItem("lighter")) then
		hintItem = scene_members.utorchSprite1
		return
	end
	
	if (sceneState.demonState == 0) then
		if (game.hasItem("demon")) then
			hintItem = scene_members.demonhint
			return
		end
	end
	if (sceneState.demonState == 1) then
		hintItem = scene_members.demonhint
		return
	end
	if (sceneState.demonState == 2 and game.hasItem("lighter")) then
		hintItem = scene_members.utorchSprite2
		return
	end
	
	if (sceneState.angelState > 0) then
		if (sceneState.ltablet1 ~= 1) then
			hintItem = scene_members.ltablet1
			return
		end
	end
	
	if (sceneState.demonState > 0) then
		if (sceneState.rtablet1 ~= 1) then
			hintItem = scene_members.rtablet1
			return
		end
	end
	
	if (sceneState.showGhost) then
		if (sceneState.photo2 ~= 1) then
			hintItem = scene_members.photo2
			return
		end
		if (sceneState.churchticket ~= 1) then
			hintItem = scene_members.churchticket
			return
		end
		
	end
	
	hintItem = scene_members.exit
	
	--[[
	 
	 если активен хог
	 	- хог
	 конец
	 
	 если не брали топор
	 	- скелет
	 конец
	 
	 если не взяли семена и есть нож
		- мешок
	 конец
	 
	 если есть демон, ангел
	 	если не решена головоломка
	 		- пьедестал демона, ангела
	 	иначе
	 		если не взята плитка
	 			- плитка
	 		конец
	 	конец
	 конец

	 если решены обе
	 	если не взято фото
	 		- фото
	 	конец
	 
	 	если не взят билет
	 		- билет
	 	конец
	 конец
	 
	 -- выход
	 
	 ]]
	
end

-- обновение экрана после каких-то действий
function updateScreen()
    
    -- ghosts
    scene_members.ghostButton:setVisible(sceneState.showGhost)
	-- skeleton
	scene_members.skeletonGhostSprite:setVisible(not (sceneState.axe == 1))
	scene_members.skeletonButton:setVisible(not (sceneState.axe == 1))
	
    -- switch off slide
    if sceneState.photo2 == 0 then
        scene_members.photo2:setVisible( true )
    end
    
	-- seeds
	scene_members.seedbagGhostSprite:setVisible(not sceneState.showSeeds)
    
    
	scene_members.seedbagButton:setVisible(not sceneState.showSeeds)
	
    
    
	scene_members.ripSprite:setVisible(sceneState.showSeeds)
	
    -- angel process
    scene_members.angelSprite1:setVisible(sceneState.angelState == 1)
    scene_members.angelSprite2:setVisible(sceneState.angelState > 1)
    scene_members.angelButton:setVisible(sceneState.angelState < 2)
    scene_members.dtorchSprite1:setVisible(sceneState.angelState < 2)
    scene_members.dtorchGhostSprite1:setVisible(sceneState.angelState < 2)
    scene_members.utorchSprite1:setVisible(sceneState.angelState > 1)
    scene_members.utorchGhostSprite1:setVisible(sceneState.angelState == 2)
    scene_members.torchButton1:setVisible(sceneState.angelState < 3)
    scene_members.angelGhostSprite:setVisible(sceneState.angelState < 2)
    scene_members.lfireParticles:setVisible(sceneState.angelState == 3)
    scene_members.angelPillarSprite:setVisible(sceneState.angelState > 0)

    if not (sceneState.ltablet1 == 1) then
        scene_members.ltablet1:setVisible(sceneState.angelState > 0)
    end
    -- demon process
    scene_members.demonSprite1:setVisible(sceneState.demonState == 1)
    scene_members.demonSprite2:setVisible(sceneState.demonState > 1)
    scene_members.demonButton:setVisible(sceneState.demonState < 2)
    scene_members.dtorchSprite2:setVisible(sceneState.demonState < 2)
    scene_members.dtorchGhostSprite2:setVisible(sceneState.demonState < 2)
    scene_members.utorchSprite2:setVisible(sceneState.demonState > 1)
    scene_members.utorchGhostSprite2:setVisible(sceneState.demonState == 2)
    scene_members.torchButton2:setVisible(sceneState.demonState < 3)
    scene_members.demonGhostSprite:setVisible(sceneState.demonState < 2)
    scene_members.rfireParticles:setVisible(sceneState.demonState == 3)
    scene_members.demonPillarSprite:setVisible(sceneState.demonState > 0)
   
    if not (sceneState.rtablet1 == 1) then
        scene_members.rtablet1:setVisible(sceneState.demonState > 0)
    end
    -- evil and ticket
     scene_members.evilSprite:setVisible(not (sceneState.demonState == 3 and sceneState.angelState == 3 ))
    if not (sceneState.churchticket == 1) then
        scene_members.churchticket:setVisible(sceneState.demonState == 3 and sceneState.angelState == 3 )
    end
    
    -- father and photo2
    scene_members.manGhostSprite:setVisible(sceneState.demonState == 3 and sceneState.angelState == 3)
    scene_members.ghostButton:setVisible(sceneState.demonState == 3 and sceneState.angelState == 3)
    if not (sceneState.photo2 == 1) then
        scene_members.photo2:setVisible(sceneState.demonState == 3 and sceneState.angelState == 3)
    end
    
    -- book
    scene_members.bookGhostSprite:setVisible(not sceneState.showGhost)
    scene_members.bookButton:setVisible(not sceneState.showGhost)
end


function showGhost()
    -- run ghost
    scene_members.manGhostSprite:setVisible(true)
    game.restartParticles(scene_members.explosionParticles)
    showDescription(LOCALIZE("S21_GHOST"),2)
    sceneState.showGhost = true
    sceneState.photo2 = 0
end


local function showSeeds()
	sceneState.showSeeds = true
	scene_members.seeds:setVisible(true)
    sceneState.bagCut = 1
    print("dagger State: ",gameState.scene24.curtainCut)
    if (gameState.scene24.curtainCut == 1) then
        game.removeItem("dagger")
    end
	updateScreen()
end

local function setupAngel()
    sceneState.angelState = 1
    updateScreen()
    game.removeItem("angel")
end

local function setupDemon()
    sceneState.demonState = 1
    updateScreen()
    game.removeItem("demon")
end

function scene_selectors.torchPressed1(sender)
    if sceneState.angelState == 2 then
        showDescription(LOCALIZE("S21_NEEDFIRE"),2)
    elseif sceneState.angelState < 2 then
        showDescription(LOCALIZE("S21_TORCHDOWN"),2)
    end
end

function scene_selectors.torchPressed2(sender)
    if sceneState.demonState == 2 then
        showDescription(LOCALIZE("S21_NEEDFIRE"),2)
    elseif sceneState.demonState < 2 then
        showDescription(LOCALIZE("S21_TORCHDOWN"),2)
    end
end

function scene_selectors.evilPressed(sender)
    showDescription(LOCALIZE("S21_EVIL"),2)
end

function scene_selectors.seedbagPressed(sender)
    if not sceneState.showSeeds then
        showDescription(LOCALIZE("S21_NEEDKNIFE"),2)
    end
end

local function lightLeftTorch()
    if sceneState.angelState == 2 then
		print("light",gameState.lighterUsages)
		gameState.lighterUsages = gameState.lighterUsages - 1
        sceneState.angelState = 3
        updateScreen()
    elseif sceneState.angelState < 2 then
        showDescription(LOCALIZE("S21_TORCHDOWN"),2)
		return
    end
	
	if (gameState.lighterUsages == 0) then
		--game.removeItem("lighter")
	end
    if sceneState.angelState + sceneState.demonState == 6 then
        showGhost()
    end
end

local function lightRightTorch()
    if sceneState.demonState == 2 then
		print("light",gameState.lighterUsages)
		gameState.lighterUsages = gameState.lighterUsages - 1
        sceneState.demonState = 3
        updateScreen()
    elseif sceneState.demonState < 2 then
        showDescription(LOCALIZE("S21_TORCHDOWN"),2)
		return
    end
	
	if (gameState.lighterUsages == 0) then
		--game.removeItem("lighter")
	end
    if sceneState.angelState + sceneState.demonState == 6 then
        showGhost()
    end    
    
end

-- использован предмет инвентаря
function inventoryItemUsed(it, x, y, action, sender)
    
    if (action == CC_RELEASE_OUTSIDE) then
        
        if it == "dagger" then
            game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.ripSprite,showSeeds, 64)
        end
        if it == "angel" then
            game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.angelSprite1,setupAngel, 64)
        end
        if it == "demon" then
            game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.demonSprite1,setupDemon, 64)
        end
        if it == "lighter" then
            game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.utorchSprite1,lightLeftTorch, 64)
        end
        if it == "lighter" then
            game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.utorchSprite2,lightRightTorch, 64)
        end
    end
end

function scene_selectors.bookPressed(sender)
	game.initSubScene("scene_21_1", "bookWindow")
end

function scene_selectors.skeletonPressed(sender)
	game.initSubScene("scene_21_2", "skeletonWindow")
end

function scene_selectors.angelPressed(sender)
    if (sceneState.angelState == 0) then
        showDescription(LOCALIZE("S21_NOSTATUE"),2)
    else
        num1 = 2
        num2 = 1
        num3 = 3
        gameType = 1
        game.initSubScene("scene_21_3", "angelWindow")
        updateMiniGame(2)
    end
    core.createSkipButton(function()
                          
                          sceneState.angelState = 2
                          game.closeSubScene()
                          scene_members.lightSprite:setVisible(true)
                          updateScreen()
                          end)
end

function scene_selectors.demonPressed(sender)
    if (sceneState.demonState == 0) then
        showDescription(LOCALIZE("S21_NOSTATUE"),2)
        else
        num1 = 2
        num2 = 1
        num3 = 3
        gameType = 2
        game.initSubScene("scene_21_4", "demonWindow")
        updateMiniGame(2)
    end
    core.createSkipButton(function()
                          
                          sceneState.demonState = 2
                          game.closeSubScene()
                          scene_members.lightSprite:setVisible(true)
                          updateScreen()
                          end)
end

function scene_selectors.hogPressed(sender)
    -- hog start here
    local m = scene_members;
    local gs = gameState.scene12;
    
    game.startSubScene("hog_21", m.minigames, scene_members.sceneMenu)
	
    sceneHOGNum = 21;
	
    game.initCommonHog(scene21)
	-- _G[]
end

-- призрак
function scene_selectors.ghostPressed(sender)
    if sceneState.showGhost then
        showDescription(LOCALIZE("S21_GHOST"),2)
    end
    --
end

function scene_selectors.armPressed(sender)
	scene_members.armButton:setVisible(false)
	scene_members.armSprite:setVisible(true)
	scene_members.axe:setVisible(true)
end



function scene_selectors.exitPressed(sender)
	if (gameState.exitActive == false) then
		return
	end
	
    game.startSceneWithSaveState("scene_20", "20_church", true);
end

function updateMiniGame(arrowNumber)
    -- 1
    if arrowNumber == 1 then
        num1 = num1 - 1
        if num1 < 1 then num1 = 1 end
    end
    if arrowNumber == 2 then
        num2 = num2 - 1
        if num2 < 1 then num2 = 1 end
    end
    if arrowNumber == 3 then
        num3 = num3 - 1
        if num3 < 1 then num3 = 1 end
    end
    if arrowNumber == 4 then
        num1 = num1 + 1
        if num1 > 3 then num1 = 3 end
    end
    if arrowNumber == 5 then
        num2 = num2 + 1
        if num2 > 3 then num2 = 3 end
    end
    if arrowNumber == 6 then
        num3 = num3 + 1
        if num3 > 3 then num3 = 3 end
    end
    
        -- mak them all invisible
    for cur = 1, 3 do
        -- heads
        scene_members["head"..cur]:setVisible(false)
        scene_members["body"..cur]:setVisible(false)
        scene_members["legs"..cur]:setVisible(false)
        scene_members["ring1"..cur]:setVisible(false)
        scene_members["ring2"..cur]:setVisible(false)
        scene_members["ring3"..cur]:setVisible(false)
    end
    -- num1
        scene_members["head"..num1]:setVisible(true)
        scene_members["body"..num2]:setVisible(true)
        scene_members["legs"..num3]:setVisible(true)
        scene_members["ring1"..num1]:setVisible(true)
        scene_members["ring2"..num2]:setVisible(true)
        scene_members["ring3"..num3]:setVisible(true)
    
    -- angel win
    if gameType == 1 then
        if num1+num2+num3 == 3 then
            -- win
            sceneState.angelState = 2
            game.closeSubSceneInTime(1)
            scene_members.lightSprite:setVisible(true)
            updateScreen()
        end
    end
    -- angel win
    if gameType == 2 then
        if num1+num2+num3 == 9 then
            -- win
            sceneState.demonState = 2
            game.closeSubSceneInTime(1)
            scene_members.lightSprite:setVisible(true)
            updateScreen()
        end
    end
    
end

function scene_selectors.arrowPressed(sender)
    print(sender)
    tolua.cast(sender, "CCNode")
    local tag = sender:getTag()
    updateMiniGame(tag)
end

-- апдейт при входе на сцену
function event()
    -- showGhost
    scene_members.seeds:setVisible(sceneState.showSeeds and (not (sceneState.seeds == 1)))
	scene_members.manGhostSprite:setVisible(sceneState.showGhost)
    
	if sceneState.photo2 == 1 then
		scene_members.photo2:removeFromParentAndCleanup(true);
	end
    if sceneState.churchticket == 1 then
		scene_members.churchticket:removeFromParentAndCleanup(true);
	end
    if sceneState.ltablet1 == 1 then
		scene_members.ltablet1:removeFromParentAndCleanup(true);
	end
    if sceneState.rtablet1 == 1 then
		scene_members.rtablet1:removeFromParentAndCleanup(true);
	end
	updateScreen()
    
   
end
