-- autostart
-- core.*
-- scene_selectors
-- scene_members

sceneState = gameState.scene22

-- показывать ли призрака
if sceneState.showGhost == nil then
    sceneState.showGhost = false
end

-- включен ли хог
if sceneState.hogIsOn == nil then
	sceneState.hogIsOn = true
end

-- цветы
if sceneState.flowersState == nil then
	sceneState.flowersState = 0
end

-- полено
if sceneState.logChopped == nil then
	sceneState.logChopped = false
end

--[[if gameState.logChopped == nil then
	gameState.logChopped = 0
end]]

function showCurrentHint()
    
	if (sceneState.hogIsOn) then
		hintItem = scene_members.hoghint
		return
	end
	
	if (sceneState.shovel ~= 1) then
		hintItem = scene_members.shovelSprite
		return
	end
	
	if (sceneState.hose ~=1) then
		hintItem = scene_members.hose
		return
	end
	
	if (sceneState.wing1 ~=1) then
		hintItem = scene_members.wing1
		return
	end
	
	if ( not sceneState.logChopped and game.hasItem("axe")) then
		hintItem = scene_members.logSprite
		return
	end
	
	if (sceneState.logChopped and sceneState.wood ~= 1) then
		hintItem = scene_members.wood
		return
	end
	
	if (sceneState.showGhost and sceneState.photo3 ~= 1) then
		hintItem = scene_members.photo3
		return
	end
	
	if (sceneState.flowersState == 0 and game.hasItem("gscissors")) then
		hintItem = scene_members.flowerhint
		return
	end
	if (sceneState.flowersState == 1 and game.hasItem("shovel")) then
		hintItem = scene_members.flowerhint
		return
	end
	if (sceneState.flowersState == 2 and game.hasItem("seeds")) then
		hintItem = scene_members.flowerhint
		return
	end
	if (sceneState.flowersState == 3 and game.hasItem("filledjug")) then
		hintItem = scene_members.flowerhint
		return
	end
	
	game.addExit(scene_members.churchhint)
	game.addExit(scene_members.exit)
	
	--[[
	 
	 если хог
	 	- хог
	 конец
	 
	 если не брали лопату
	 	- лопата
	 конец
	 
	 если не брали шланг
	 	- шланг
	 конец
	 
	 если не брали крыло
	 	- крыло
	 конец
	 
	 если полено не колото и есть топор
	 	- полено
	 конец
	 
	 если призрак и не брали фото
	 	- фото
	 конец
	 
	 - состояния цветов
	 
	 -- церковь
	 
	 ]]
	
	
end

-- обновение экрана после каких-то действий
function updateScreen()
	-- полено
    scene_members.logSprite:setVisible(not sceneState.logChopped)
    scene_members.logGhostSprite:setVisible(not sceneState.logChopped)
    scene_members.logButton:setVisible(not sceneState.logChopped)
    
    if not (sceneState.wood == 1) then
        scene_members.wood:setVisible(sceneState.logChopped)
    end
    
    if not (sceneState.photo3 == 1) then
        scene_members.photo3:setVisible(sceneState.showGhost)
    end
    
    -- могилка
    -- засохшие цветы
    scene_members.deadflowersSprite:setVisible(sceneState.flowersState == 0)
    scene_members.deadflowersGhostSprite:setVisible(sceneState.flowersState == 0)
    -- пустая земля
    scene_members.earthGhostSprite:setVisible(sceneState.flowersState == 1)
    -- посажено
    scene_members.plantedflowersSprite:setVisible(sceneState.flowersState == 2 or sceneState.flowersState == 3)
    scene_members.plantedGhostSprite:setVisible(sceneState.flowersState == 2 or sceneState.flowersState == 3)
    -- цветы
    scene_members.liveflowersSprite:setVisible(sceneState.flowersState == 4)
    
    -- лопата
    scene_members.shovelSprite:setVisible(not (sceneState.shovel == 1))
    scene_members.shovelButton:setVisible(not (sceneState.shovel == 1))

end

function scene_selectors.hogPressed(sender)
    -- hog start here
    local m = scene_members;
    local gs = gameState.scene12;
    
    game.startSubScene("hog_22", m.minigames, scene_members.sceneMenu)
	
    sceneHOGNum = 22;
	
    game.initCommonHog(scene22)
	-- _G[]
end

function scene_selectors.flowersPressed(sender)
	if (sceneState.flowersState == 0) then
		showDescription(LOCALIZE("S22_FLOWERS1"),3)
	end
	if (sceneState.flowersState == 1) then
		showDescription(LOCALIZE("S22_FLOWERS2"),3)
	end
	if (sceneState.flowersState == 2) then
		showDescription(LOCALIZE("S22_FLOWERS3"),3)
	end
	if (sceneState.flowersState == 3) then
		showDescription(LOCALIZE("S22_FLOWERS4"),3)
	end
end

function showGhost()
    -- run ghost
    scene_members.manGhostSprite:setVisible(true)
    game.restartParticles(scene_members.explosionParticles)
	
    sceneState.showGhost = true
    sceneState.photo3 = 0
    
end

local function chopLog()
    if not sceneState.logChopped then
        scene_members.boardsParticles:setVisible(true)
        game.restartParticles(scene_members.boardsParticles)
        sceneState.logChopped = true
        scene_members.wood:setVisible(true)
        updateScreen()
		--gameState.logChopped = 1
		if (gameState.scene20.boardsSmashed == 1) then
        	game.removeItem("axe")
		end
    end
end

function scene_selectors.logPressed()
    showDescription(LOCALIZE("S22_CHOP"),2)
end

local function cutFlowers()
    print("doit",sceneState.flowersState)
    if (sceneState.flowersState == 0) then
        sceneState.flowersState = 1
        updateScreen()
        game.removeItem("gscissors")
		scene_members.hogParticles:setVisible(sceneState.hogIsOn)
		scene_members.hogButton:setEnabled(sceneState.hogIsOn)
    end
end

local function digGround()
    if (sceneState.flowersState == 1) then
        sceneState.flowersState = 2
        updateScreen()
        game.removeItem("shovel")
    end
end

local function plantSeeds()
    if (sceneState.flowersState == 2) then
        sceneState.flowersState = 3
        updateScreen()
        game.removeItem("seeds")
    end
end

local function growSeeds()
    if (sceneState.flowersState == 3) then
        sceneState.flowersState = 4
        game.removeItem("filledjug")
        showGhost()
        updateScreen()
    end
end

-- использован предмет инвентаря
function inventoryItemUsed(it, x, y, action, sender)
    if (action == CC_RELEASE_OUTSIDE) then
		
        if it == "axe" then
            game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.logSprite,chopLog, 64)
        end
		
        if it == "gscissors" then
            game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.deadflowersSprite,cutFlowers, 64)
        end
        
        if it == "shovel" then
            game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.deadflowersSprite,digGround, 64)
        end
        
        if it == "seeds" then
            game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.deadflowersSprite,plantSeeds, 64)
        end
        if it == "filledjug" then
            game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.deadflowersSprite,growSeeds, 64)
        end
    end
end


-- призрак
function scene_selectors.ghostPressed(sender)
		if(sceneState.showGhost)then
		showDescription(LOCALIZE("S22_FATHER"),3)
		end
end

function scene_selectors.shovelPressed(sender)
    if not (sceneState.shovel == 1) then
		game.initSubScene("scene_22_2", "shovelWindow")
    end
end

function scene_selectors.twinPressed(sender)
        game.initSubScene("scene_22_1", "twinWindow")
end

function scene_selectors.entrancePressed(sender)
    game.startSceneWithSaveState("scene_23", "23_belltower", true);
end



function scene_selectors.exitPressed(sender)
	if (gameState.exitActive == false) then
		return
	end
	
    game.startSceneWithSaveState("scene_20", "20_church", true);
end

-- апдейт при входе на сцену
function event()
	-- showGhost
	
	scene_members.manGhostSprite:setVisible(sceneState.showGhost)
	
	if sceneState.photo3 == 1 then
		scene_members.photo3:removeFromParentAndCleanup(true);
	end
	
    if sceneState.wing1 == 1 then
		scene_members.wing1:removeFromParentAndCleanup(true);
	end
   
    if sceneState.wood == 1 then
		scene_members.wood:removeFromParentAndCleanup(true);
	end
    if sceneState.hose == 1 then
		scene_members.hose:removeFromParentAndCleanup(true);
	end
    
	updateScreen()
	

end
