-- autostart
-- core.*
-- scene_selectors
-- scene_members

sceneState = gameState.scene23

-- показывать ли призрака
if sceneState.showGhost == nil then
    sceneState.showGhost = false
end

-- открыта ли дверь
if sceneState.doorOpen == nil then
    sceneState.doorOpen = false
end

-- открыта ли дверь
if sceneState.filledJug == nil then
    sceneState.filledJug = false
end

-- открыта ли дверь
if sceneState.keyUsed == nil then
    sceneState.keyUsed = false
end

function showCurrentHint()
    
	if (sceneState.wing2 ~= 1) then
		hintItem = scene_members.wing2
		return
	end
	
	if (game.hasItem("emptyjug")) then
		hintItem = scene_members.fountainhint
		return
	end
	
	if (sceneState.filledJug == true and sceneState.filledjug ~=1) then
		hintItem = scene_members.filledjug
		return
	end
	
	if (game.hasItem("chaplet")) then
		hintItem = scene_members.chairhint
		return
	end
	
	if (game.hasItem("crosskey")) then
		hintItem = scene_members.doorhint
		return
	end
	
	if (sceneState.showGhost and sceneState.photo4 ~= 1) then
		hintItem = scene_members.photo4
		return
	end
	
	game.addExit(scene_members.stairshint)
	game.addExit(scene_members.exit)
	
	if (sceneState.usedKey) then
		game.addExit(scene_members.doorhint)
	end
	
	--[[
	 
	 если не взято крыло
	 	- крыло
	 конец
	 
	 если есть пустой кухшин
	 	- фонтан
	 конец
	 
	 если есть распятие
	 	- стул
	 конец
	 
	 если есть ключ
	 	- дверь
	 конец
	 
	 если есть призрак и не взято фото
	 	- фото
	 конец
	 
	 -- выходы
	 
	 ]]
	
end

-- обновение экрана после каких-то действий
function updateScreen()

    scene_members.ghostButton:setVisible(sceneState.showGhost)
	-- дверь
    scene_members.openSprite:setVisible(sceneState.doorOpen)
    scene_members.doorGhostSprite:setVisible(not sceneState.doorOpen)
    
    
    if not (sceneState.filledjug == 1) then
        scene_members.filledjug:setVisible(sceneState.filledJug)
    end
    
    if not (sceneState.photo4 == 1) then
        scene_members.photo4:setVisible(sceneState.showGhost)
    end
    
    -- фонтан
    scene_members.waterGhostSprite:setVisible(not sceneState.filledJug)
    scene_members.waterButton:setVisible(not sceneState.filledJug)
    
    -- стул
    scene_members.chairGhostSprite:setVisible(not sceneState.showGhost)
    scene_members.chairButton:setVisible(not sceneState.showGhost)

    
end


function showGhost()
    -- run ghost
    scene_members.manGhostSprite:setVisible(true)
    game.restartParticles(scene_members.explosionParticles)
	
    sceneState.showGhost = true
    sceneState.photo4 = 0
    
end

local function fillJar()
    game.removeItem("emptyjug")
    sceneState.filledJug = true
    updateScreen()
end

local function useKey()
	if(scene_members.keySprite == nil) then
	return
	end
    game.removeItem("crosskey")
    sceneState.usedKey = true
    scene_members.keyButton:setVisible(true)
end

function scene_selectors.keyPressed(sender)
    -- open door
    scene_members.keyButton:setVisible(false)
    scene_members.keySprite:setVisible(true)
    sceneState.doorOpen = true
    updateScreen()
    game.closeSubSceneInTime(1)
end

local function useChaplet()
	if(scene_members.chapletSprite == nil)then
	return
	end
    scene_members.chapletGhostSprite:setVisible(false)
    scene_members.chapletSprite:setVisible(true)
    game.removeItem("chaplet")
    showGhost()
    updateScreen()
    game.closeSubSceneInTime(1)
end

-- использован предмет инвентаря
function inventoryItemUsed(it, x, y, action, sender)
    if (action == CC_RELEASE_OUTSIDE) then
		
        if it == "emptyjug" then
            game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.waterSprite,fillJar, 64)
        end
        if it == "crosskey" then
            game.enablesItemfromInventory(x,y,scene_members.keySprite,useKey, 64)
        end
        if it == "chaplet" then
            game.enablesItemfromInventory(x,y,scene_members.chapletSprite,useChaplet, 64)
        end
    end
end


-- призрак
function scene_selectors.ghostPressed(sender)
    if sceneState.showGhost then
		showDescription(LOCALIZE("S23_FATHER"),2)
    end
	--
end

function scene_selectors.entrancePressed(sender)
    game.startSceneWithSaveState("scene_25", "25_bellroom", true);
end

function scene_selectors.chairPressed(sender)
		game.initSubScene("scene_23_2", "chairWindow",nil,function() scene_members.chapletSprite = nil end)
end

function scene_selectors.waterPressed(sender)
    showDescription(LOCALIZE("S23_WATER"),2)
end

function scene_selectors.doorPressed(sender)
    if not sceneState.doorOpen then        
        game.initSubScene("scene_23_1", "doorWindow",nil,function() scene_members.keySprite = nil end)
		scene_members.keyButton:setVisible(sceneState.usedKey)
	else
        game.startSceneWithSaveState("scene_24", "24_cabinet", true);
    end
end



function scene_selectors.exitPressed(sender)
	if (gameState.exitActive == false) then
		return
	end
	
    game.startSceneWithSaveState("scene_22", "22_graveyard", true);
end

-- апдейт при входе на сцену
function event()
	-- showGhost
	
	scene_members.manGhostSprite:setVisible(sceneState.showGhost)

    
	if sceneState.photo4 == 1 then
		scene_members.photo4:removeFromParentAndCleanup(true);
	end
	
    if sceneState.wing2 == 1 then
		scene_members.wing2:removeFromParentAndCleanup(true);
	end
    
    if sceneState.filledjug == 1 then
		scene_members.filledjug :removeFromParentAndCleanup(true);
	end
    
	updateScreen()
	
end
