-- autostart
-- core.*
-- scene_selectors
-- scene_members

sceneState = gameState.scene24

-- показывать ли призрака
if sceneState.showGhost == nil then
    sceneState.showGhost = false
end

-- показывать ли призрака
if sceneState.clothOpen == nil then
    sceneState.clothOpen = false
end

if sceneState.boxState == nil then
    sceneState.boxState = 0
end

-- левая панель установлена
if sceneState.leftSetup == nil then
    sceneState.leftSetup  = false
end

-- правая панель установлена
if sceneState.rightSetup == nil then
    sceneState.rightSetup  = false
end

-- половинка фото установлена
if sceneState.photoSetup == nil then
    sceneState.photoSetup  = false
end

if sceneState.curtainCut == nil then
    sceneState.curtainCut = 0
end

function showCurrentHint()
   
    if (sceneState.emptyjug ~= 1) then
        hintItem = scene_members.emptyjug
        return
    end
    
    if (sceneState.ltablet2 ~= 1) then
        hintItem = scene_members.tablethint
        return
    end
    
    if (sceneState.boxState > 0) then
        if (sceneState.rtablet2 ~= 1) then
            hintItem = scene_members.boxhint
            return
        end
    else
        if (game.hasItem("coin")) then
            hintItem = scene_members.boxhint
            return
        end
    end
    
    if (game.hasItem("rtablet",2)) then
        hintItem = scene_members.lefthint
        return
    end
    if (game.hasItem("ltablet",2)) then
        hintItem = scene_members.righthint
        return
    end
    
    if (sceneState.clothOpen) then
        if (sceneState.angel ~= 1) then
            hintItem = scene_members.angel
            return
        end
    else
        if (game.hasItem("dagger")) then
            hintItem = scene_members.clothhint
            return
        end
    end
    
    if (sceneState.leftSetup and sceneState.rightSetup and (sceneState.showGhost == false)) then
        hintItem = scene_members.puzzlehint
        return
    end
    
    if (game.hasItem("bride")) then
        hintItem = scene_members.photohint
        return
    end
    
    if (sceneState.showGhost and sceneState.photoSetup and (sceneState.photo5 ~= 1)) then
        hintItem = scene_members.photo5
        return
    end
    
    hintItem = scene_members.exit
    
    --[[
     
     если не взят кухшин
        - кухшин
     конец
     
     если не взята плитка
        - плитка
     конец
     
     если ящик октрыт
        если плитка не взята
            - ящик
        конец
     иначе
        если есть монетка
            - ящик
        конец
     конец
     
     если собрана левая плитка
        - место под плитку
     конец
     
     если собрана правая плитка
        - место под плитку
     конец
     
     если не разрезано
        если есть кинжал
            - разрез
        конец
     иначе
        если ангел не взят
            -ангел
        конец
     конец
     
     если обе собраны
        - паззл
     конец
     
     если есть фото
        - на рамку
     конец
     
     - выход
     
     
     ]]
    
end

-- обновение экрана после каких-то действий
function updateScreen()

    if not (sceneState.photo5 == 1) then
        scene_members.photo5:setVisible(sceneState.showGhost and sceneState.photoSetup)
    else
        scene_members.brideSprite:setVisible(false)
    end
    
    if not (sceneState.angel == 1) then
        scene_members.angel:setVisible(sceneState.clothOpen)
    end
	
	scene_members.ghostButton:setVisible(sceneState.showGhost)
	
	-- coin box
	scene_members.closedSprite:setVisible(sceneState.boxState == 0)
    scene_members.closedGhostSprite:setVisible(sceneState.boxState == 0)
	scene_members.openSprite:setVisible(sceneState.boxState == 1)
	scene_members.openGhostSprite:setVisible(sceneState.boxState == 1 and (not (sceneState.rtablet2 == 1)))
	scene_members.boxButton:setVisible((not (sceneState.boxState == 2)) and (not (sceneState.rtablet2 == 1)))
	
	-- cloth
	scene_members.clothSprite:setVisible(sceneState.clothOpen)
    scene_members.clothGhostSprite:setVisible(not sceneState.clothOpen)
	scene_members.clothButton:setVisible(not sceneState.clothOpen)
	
	-- tablet
    scene_members.tabletGhostSprite:setVisible(not (sceneState.ltablet2 == 1))
	scene_members.tabletButton:setVisible(not (sceneState.ltablet2 == 1))
    scene_members.tabletSprite:setVisible(not (sceneState.ltablet2 == 1))
	
	-- левая панель
    scene_members.leftGhostSprite:setVisible(not sceneState.leftSetup)
	scene_members.leftButton:setVisible(not sceneState.leftSetup)
	scene_members.ltabletSprite:setVisible(sceneState.leftSetup)

	-- правая панель
    scene_members.rightGhostSprite:setVisible(not sceneState.rightSetup)
	scene_members.rightButton:setVisible(not sceneState.rightSetup)
	scene_members.rtabletSprite:setVisible(sceneState.rightSetup)

	-- витраж
    scene_members.vitrageGhostSprite:setVisible(not sceneState.showGhost)
	scene_members.vitrageButton:setVisible(not sceneState.showGhost)
	scene_members.completeSprite:setVisible(sceneState.showGhost)
	scene_members.incompleteSprite:setVisible(not sceneState.showGhost)
    
    --
    scene_members.brideSprite:setVisible(sceneState.photoSetup)
    scene_members.frameGhostSprite:setVisible(not sceneState.photoSetup)
    
end

function showGhost()
    -- run ghost
    scene_members.manGhostSprite:setVisible(true)
    game.restartParticles(scene_members.explosionParticles)
	
    sceneState.showGhost = true
    
    
end

local function openBox()
	sceneState.boxState = 1
	updateScreen()
end

local function openCloth()
	sceneState.clothOpen = true
	updateScreen()
end

local function dropCoin()
	scene_members.coinSprite:setVisible(true)
	scene_members.coinSprite:runAction(CCFadeOut:create(1))
	scene_members.coinSprite:runAction(CCSequence:createWithTwoActions(CCMoveBy:create(1,ccp(0,-50)), CCCallFunc:create(openBox)))
	game.removeItem("coin")
end

local function cutCloth()
	scene_members.knifeSprite:setVisible(true)
	scene_members.knifeSprite:runAction(CCFadeOut:create(1))
	scene_members.knifeSprite:runAction(CCSequence:createWithTwoActions(CCMoveBy:create(1,ccp(-150,0)), CCCallFunc:create(openCloth)))
    sceneState.curtainCut = 1
    if (gameState.scene21.bagCut == 1) then
        game.removeItem("dagger")
    end
end

local function setLeft()
	sceneState.leftSetup = true
	updateScreen()
	game.removeItem("rtablet",2)
end

local function setRight()
	sceneState.rightSetup = true
	updateScreen()
	game.removeItem("ltablet",2)
end

local function setBride()
	sceneState.photoSetup = true
	updateScreen()
	game.removeItem("bride")
end

-- использован предмет инвентаря
function inventoryItemUsed(it, x, y, action, sender)
    if (action == CC_RELEASE_OUTSIDE) then
		
        if it == "coin" then
            game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.closedSprite,dropCoin, 64)
        end
        if it == "dagger" then
            game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.clothSprite,cutCloth, 64)
        end
        if it == "rtablet" then
            game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.ltabletSprite,setLeft, 64)
        end
        if it == "ltablet" then
            game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.rtabletSprite,setRight, 64)
        end
        if it == "bride" then
            game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.brideSprite,setBride, 64)
        end
    end
end

function scene_selectors.rightPressed(sender)
showDescription(LOCALIZE("S24_RIGHTTAB"),2)
end
function scene_selectors.leftPressed(sender)
showDescription(LOCALIZE("S24_LEFTTAB"),2)
end
function scene_selectors.clothPressed(sender)
showDescription(LOCALIZE("S24_CURTAIN"),2)
end

function scene_selectors.boxPressed(sender)
	if sceneState.boxState == 1 then
		game.initSubScene("scene_24_1", "boxWindow")
	else
		showDescription(LOCALIZE("S24_NEEDOPEN"),2)
	end
end

local function setVitrage()
    print("SETVITRAGE!!!!")
	showGhost()
	updateScreen()
end

function scene_selectors.vitragePressed(sender)
	if sceneState.leftSetup and sceneState.rightSetup then
		--game.initSubScene("scene_24_3", "vitrageWindow")
		core.minigames.puzzle.loadMiniGame("scene_24_3", "vitrageWindow", setVitrage, {{245, 349},{217, 209},{247,167},{304, 318},{340,301},{305,252},{346,207},{304,101},{342,75},{417, 298}, {419,226}, {420,98}},
										   nil);
		
	else
		showDescription(LOCALIZE("S24_VITRAGE"),2)
	end
end

function scene_selectors.tabletPressed(sender)
	game.initSubScene("scene_24_2", "tabletWindow")
end

-- призрак
function scene_selectors.ghostPressed(sender)
    if sceneState.showGhost then
		showDescription(LOCALIZE("S24_FATHER"),2)
    end
	--
end



function scene_selectors.exitPressed(sender)
	if (gameState.exitActive == false) then
		return
	end
	
    game.startSceneWithSaveState("scene_23", "23_belltower", true);
end

-- апдейт при входе на сцену
function event()
	-- showGhost
	
	scene_members.manGhostSprite:setVisible(sceneState.showGhost)
	
    
	if sceneState.photo5 == 1 then
		scene_members.photo5:removeFromParentAndCleanup(true);
	end

	if sceneState.angel == 1 then
		scene_members.angel:removeFromParentAndCleanup(true);
	end
	
	if sceneState.emptyjug == 1 then
		scene_members.emptyjug:removeFromParentAndCleanup(true);
	end
	
	updateScreen()
	
end
