-- autostart
-- core.*
-- scene_selectors
-- scene_members

sceneState = gameState.scene25
game.isSceneNeedProcessDialog = true

-- показывать ли призрака
if sceneState.showGhost == nil then
    sceneState.showGhost = false
end

-- разбито ли окно
if sceneState.bellState == nil then
    sceneState.bellState = 0
end

-- убрана ли паутина
if sceneState.webRemoved == nil then
    sceneState.webRemoved = false
end

if not sceneState.photoGameOpen then
	sceneState.photoGameOpen = 0
end

if not sceneState.fathercrystal then
	sceneState.fathercrystal = 1
end

if not sceneState.filmStarted then
	sceneState.filmStarted = 0
end


if not sceneState.DialogStarted then
	sceneState.DialogStarted = 0
end


function showCurrentHint()
    
    if (sceneState.dagger ~= 1) then
        hintItem = scene_members.dagger
        return
    end
    
    if (sceneState.bride ~= 1) then
        hintItem = scene_members.picturehint
        return
    end
    
    if (sceneState.webRemoved) then
        if (sceneState.ladder ~= 1) then
            hintItem = scene_members.ladderhint
            return
        end
    else
        if (game.hasItem("broom")) then
            hintItem = scene_members.ladderhint
            return
        end
    end
    
	print("bellstate ", sceneState.bellState)
    if ((sceneState.bellState == 0 and game.hasItem("tongue")) or (sceneState.bellState == 1)) then
        hintItem = scene_members.bellhint
        return
    end
    
    if (game.hasItem("photo",6)) then
        hintItem = scene_members.bookhint
        return
    end
    
    if (sceneState.showGhost and sceneState.photo6 ~= 1) then
        hintItem = scene_members.photo6
        return
    end
    
	if (sceneState.fathercrystal == 0) then
		hintItem = scene_members.fathercrystal
		return
	end
	
    hintItem = scene_members.exit
    
    --[[
     если не взят кинжал
        - кинжал
     конец
     
     если не взята фото
        - на картинку
     конец
     
     если паутина убрана
        если лестница не взята
            -лестница
        конец
     иначе
        если есть метла
            - паутина
        конец
     конец
     
     - колокол
     
     если есть фото +6
        - книга
     конец
     
     если есть призрак и не подобрана фотка
        - фотка
     конец
     
     -- выход
     
     ]]
    
end

-- обновение экрана после каких-то действий
function updateScreen()
	
    scene_members.ghostButton:setVisible(sceneState.showGhost)

	-- ladder
	scene_members.ladderSprite:setVisible(not sceneState.webRemoved)

	if not (sceneState.ladder == 1) then
		scene_members.ladder:setVisible(sceneState.webRemoved)
	end
	
	scene_members.ladderButton:setVisible(not sceneState.webRemoved)
	scene_members.ladderGhostSprite:setVisible(not sceneState.webRemoved)
	
    if (not (sceneState.photo6 == 1) and scene_members.photo6) then
        scene_members.photo6:setVisible(sceneState.showGhost)
    end
	
	-- bell
	scene_members.tongueSprite:setVisible(sceneState.bellState > 0)
	scene_members.bellGhostSprite:setVisible(sceneState.bellState < 2)
	-- window
	scene_members.shardsSprite:setVisible(sceneState.bellState > 2)
	scene_members.vitrageSprite:setVisible(sceneState.bellState < 3)
	scene_members.lightSprite1:setVisible(sceneState.bellState < 3)
	scene_members.lightSprite2:setVisible(sceneState.bellState > 2)

	-- picture
    scene_members.pictureGhostSprite:setVisible(not (sceneState.bride == 1))
	scene_members.pictureButton:setVisible(not (sceneState.bride == 1))
	
end

local function showFinalClip()
    core.sendFlurryEvent("Level_<Level05>_Complete")
    sceneState.filmStarted = 1
    sceneState.photoGameOpen = 0
    runFinalClip("cutScene5parts","scene_25", "25_bellroom",sceneState.cutMovie,6,sceneState.ghost,"S25_DIALOG1","S25_DIALOG2",sceneState.fathercrystal,"fathercrystal","scene25")
end


local function showGhost()
    -- run ghost
    scene_members.manGhostSprite:setVisible(true)
    game.restartParticles(scene_members.explosionParticles)
	showDescription(LOCALIZE("S25_GHOST"),2)
    sceneState.showGhost = true
    sceneState.photo6 = 0
    
end

local function setBelltongue()
    print("setTonge")
	sceneState.bellState = 1
	updateScreen()
	game.removeItem("tongue")
end

local function setBroom()
	sceneState.webRemoved = true
	updateScreen()
	game.removeItem("broom")
end



-- использован предмет инвентаря
function inventoryItemUsed(it, x, y, action, sender)
    if (action == CC_RELEASE_OUTSIDE) then
		print(it, x, y)
        if it == "tongue" then
            game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.bellButton,setBelltongue, 64)
            
        end
        if it == "broom" then
            game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.ladderSprite,setBroom, 64)
        end
        
        if it == "photo" then
            game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.photoGame, function()
                                                       sceneState.photoGameOpen = 1
                                                       scene_members.photoGame:setVisible(sceneState.photoGameOpen == 1)
                                                       scene_members.photoGame:setEnabled(sceneState.photoGameOpen == 1)
                                                       game.removeItem("photo",6)

                                                       core.minigames.puzzle.loadMiniGame("scene_25_2", "photoCardsMiniGame", showFinalClip, {{90,333},{554, 218},{84, 95},{147,214},{423,342},{242,80}});
                                                       end,action)
        end
		
    end
end

local function smashWindow()
	sceneState.bellState = 3
	showGhost()
	updateScreen()
	scene_members.glassParticles:setVisible(true)
	game.restartParticles(scene_members.glassParticles)
	
end

function scene_selectors.bellPressed(sender)
	if sceneState.bellState == 0 then
		showDescription(LOCALIZE("S25_NOTONGUE"),2)
	elseif sceneState.bellState == 1 then
		sceneState.bellState = 2
		core.runAnimation("belltoll",0,scene_members.bellLayer)
		updateScreen()
		scene_members.bellSprite:runAction(CCSequence:createWithTwoActions(CCDelayTime:create(2), CCCallFunc:create(smashWindow)))
	end
end

function scene_selectors.albumPressed(sender)
    showDescription(LOCALIZE("S25_PHOTOALBUM"),2)
end

function scene_selectors.photoGamePressed(sender)
    core.minigames.puzzle.loadMiniGame("scene_25_2", "photoCardsMiniGame", showFinalClip, {{90,333},{554, 218},{84, 95},{147,214},{423,342},{242,80}});
end
-- призрак
function scene_selectors.ghostPressed(sender)
    if sceneState.showGhost then
		showDescription(LOCALIZE("S25_GHOST"),2)
    end
	--
end

-- картина
function scene_selectors.picturePressed(sender)
	game.initSubScene("scene_25_1", "pictureWindow")
end

-- лестница
function scene_selectors.ladderPressed(sender)
	showDescription(LOCALIZE("S25_WEB"),2)
end



function scene_selectors.exitPressed(sender)
	if (gameState.exitActive == false) then
		return
	end
	
    game.startSceneWithSaveState("scene_23", "23_belltower", true);
end

-- апдейт при входе на сцену
function event()
	-- showGhost
    --game.addItem("photo6",6)
	
	scene_members.manGhostSprite:setVisible(sceneState.showGhost)
	
    --crystal
	scene_members.fathercrystal:setVisible(sceneState.fathercrystal == 0)
	scene_members.fathercrystal:setVisible(sceneState.fathercrystal == 0)
    
    
	if sceneState.photo6 == 1 then
		scene_members.photo6:removeFromParentAndCleanup(true);
	end
	
    if sceneState.ladder == 1 then
		scene_members.ladder:removeFromParentAndCleanup(true);
	end
    
    if sceneState.dagger == 1 then
		scene_members.dagger :removeFromParentAndCleanup(true);
	end
    
    scene_members.photoGame:setVisible(sceneState.photoGameOpen == 1)
    
    
	updateScreen()
    
    if(sceneState.filmStarted == 1) then
        sceneState.filmStarted = runFinalClip("cutScene5parts","scene_25", "25_bellroom",sceneState.cutMovie,6,sceneState.ghost,"S25_DIALOG1","S25_DIALOG2",sceneState.fathercrystal,"fathercrystal","scene25")
    end
    
    if(sceneState.DialogStarted == 1) then
        showDialog(sceneState.ghost,"S25_DIALOG1","S25_DIALOG2",sceneState.fathercrystal,"fathercrystal","scene25")
    end
	
end
