-- autostart
-- core.*
-- scene_selectors
-- scene_members

sceneState = gameState.scene26
game.isSceneNeedProcessDialog = true

if not sceneState.coin1 then
	sceneState.coin1 = 0
end

if not sceneState.clothes then
	sceneState.clothes = 0
end

if not sceneState.cup then
	sceneState.cup = 0
end

if not sceneState.barsBroken then
	sceneState.barsBroken = 0
end

if not sceneState.batery1 then
	sceneState.batery1 = 0
end
if not sceneState.batery2 then
	sceneState.batery2 = 0
end

if not sceneState.jugpouring then
	sceneState.jugpouring = 0
end


if not sceneState.medicine then
	sceneState.medicine = 0
end

if not sceneState.pepper then
	sceneState.pepper = 0
end

if not sceneState.cupPlaced3 then
	sceneState.cupPlaced3 = 0
end

if not sceneState.winBroken then
	sceneState.winBroken = 0
end

--можно ли выйти из комнаты
if not sceneState.canEscape then
	sceneState.canEscape = 0
end

if sceneState.firstTime == nil then
	sceneState.firstTime = true
end


if sceneState.hogIsOn == nil then
	sceneState.hogIsOn = true
end

if not sceneState.firstStart then
	sceneState.firstStart = 1
    core.sendFlurryEvent("Level_<Level06>_Start")
end

local bgMusicPath = CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/music/m_0004_prison.mp3")
SimpleAudioEngine:sharedEngine():playBackgroundMusic(bgMusicPath, true)
SimpleAudioEngine:sharedEngine():setBackgroundMusicVolume(0.4)


function showCurrentHint()
    
	if (sceneState.hogIsOn) then
		hintItem = scene_members.hoghint
        print("inside1")
		return
	end
	
	if (sceneState.coin1 ~= 1) then
		hintItem = scene_members.coin1
        print("inside2")
		return
	end
	
	if (sceneState.clothes ~= 1) then
		hintItem = scene_members.clothes
        print("inside3")
		return
	end
	
	if (sceneState.cupempty ~= 1) then
		hintItem = scene_members.cupempty
        print("inside4")
		return
	end
	
	if (sceneState.batery1 ~= 1 or sceneState.batery2 ~= 1) then
		hintItem = scene_members.batterieshint
        print("inside5")
		return
	end
	
	if (sceneState.medicine ~= 1) then
		hintItem = scene_members.closethint
        print("inside6")
		return
	end
	
	if (sceneState.winBroken == 1 and sceneState.pepper ~= 1) then
		hintItem = scene_members.closethint
        print("inside7")
		return		
	end
	
	if (game.hasItem("jugpouring") and (sceneState.barsBroken == 0)) then
		hintItem = scene_members.electrohint
        print("inside9")
		return
	end
	
	if (sceneState.cup < 2) then
		hintItem = scene_members.tablehint
        print("inside10")
		return
	end
	
    if (game.hasItem("singlecoin") and (not game.hasItem("pepper")) and game.hasItem("stick")) then
        print("inside11")
		hintItem = scene_members.closethint
        
		return
	end
    
	-- стакан
	
	hintItem = scene_members.windowhint
	
end


function game.onSceneStartCustom()
    local function buttonsClick()
        if(tmp.nextDialog == nil)then
           showProcessDialogWithDiscription(LOCALIZE("S26_DIALOG2"),buttonsClick,buttonsClick)
            tmp.nextDialog = 1
        else
            closeProcessDialog()
            sceneState.firstTime = false
        end
    end
    if(sceneState.firstTime)then
        showProcessDialogWithDiscription(LOCALIZE("S26_DIALOG1"),nil,buttonsClick)
        sceneState.firstTime = false
    end
end

function scene_selectors.exitPressed(sender)
	if (gameState.exitActive == false) then
		return
	end
	
	game.startSceneWithSaveState("scene_1", "01_station", true);  
end



function scene_selectors.exitSquareButtonPressed(sender)
    if(sceneState.barsBroken == 0)then
        showDescription(LOCALIZE("S26_WINDOWCLOSED"))
        return
    end
    if(sceneState.canEscape < 2 and sceneState.barsBroken == 1)then
        showDescription(LOCALIZE("S26_ESCAPE"))
        return
    end
    
	game.startSceneWithSaveState("scene_27", "27_square", true);
end

local function openWindow()
	
	if(sceneState.barsBroken == 1 )then
		scene_members.redLight:setVisible(false)
		scene_members.greenLight:setVisible(true)
		scene_members.ironBars:setVisible(false)
		scene_members.boxGhost:setVisible(false)
		scene_members.barsButton:setVisible(false)
		scene_members.closetWindow:runAction(CCFadeTo:create(0.4,0))
		scene_members.openedWindow:runAction(CCFadeTo:create(0.4,255))
        showDescription(LOCALIZE("S26_OPENWINDOW"))
        effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0068_alarma.mp3"))
        effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0112_metalicunlockhigh.mp3"))
	end
end

function resetBars()
	scene_members.barsBroken = nil
	core.CCLOG("bars nil!")
end

function resetCup()
	scene_members.cupPlaced1 = nil
	core.CCLOG("cup nil!")
end


function scene_selectors.barsButtonPressed(sender)
    specificSounOnOpen = true
	print("ERROR nested initSubScene: ", resetBars)
	game.initSubScene("scene_26_0","bars",resetBars,openWindow)
    effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0058_useplastic.mp3"))
    showDescription(LOCALIZE("S26_BARS"))
end

local function removeItems()
    scene_members.glassFull = nil
	if(sceneState.medicine == 1) then
		if(scene_members.medPils) then
			scene_members.medPils:setVisible(false)
		end
	end
	if(sceneState.pepper == 1) then
		if(scene_members.pepCan)then
			scene_members.pepCan:setVisible(false)
		end
	end
end
function scene_selectors.cupBoardButtonPressed(sender)
    specificSounOnOpen = true
	game.initSubScene("scene_26_2","cupBoard",nil,removeItems)
    effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0058_useplastic.mp3"))
	scene_members.medicine:setVisible(sceneState.medicine == 0)
	scene_members.medicine:setTouchEnabled(sceneState.medicine == 0)
	scene_members.pepper:setVisible(sceneState.pepper == 0)
	scene_members.pepper:setTouchEnabled(sceneState.winBroken == 1)
	scene_members.glassFull:setVisible(sceneState.winBroken == 0)
	scene_members.glassBroken:setVisible(sceneState.winBroken == 1)
    showDescription(LOCALIZE("S26_PILS"))

end


function scene_selectors.drawerButtonPressed(sender)
    specificSounOnOpen = true
	game.initSubScene("scene_26_1","drawer")
    effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0057_lightwoodslide.mp3"))
	scene_members.batery1:setVisible(sceneState.batery1 == 0)
	scene_members.batery1:setTouchEnabled(sceneState.batery1 == 0)
	scene_members.batery2:setVisible(sceneState.batery2 == 0)
	scene_members.batery2:setTouchEnabled(sceneState.batery2 == 0)
end

local function removeCups()
	if(sceneState.jugpouring == 1) then
		scene_members.winJug:setVisible(false)
	end
	scene_members.cupWater:setVisible(sceneState.cup > 0 and sceneState.cupPlaced3 == 0)
	
end
function scene_selectors.jugAndCupButtonPressed(sender)
    specificSounOnOpen = true
	game.initSubScene("scene_26_3","jugAndCup",resetCup,removeCups)
    effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0058_useplastic.mp3"))
	scene_members.jugpouring:setVisible(sceneState.jugpouring == 0)
	scene_members.jugpouring:setTouchEnabled(sceneState.jugpouring == 0)
	scene_members.cupPlaced3:setVisible(sceneState.cup == 3)
	scene_members.cupPlaced3:setTouchEnabled(sceneState.cup == 3)
    if(sceneState.jugpouring == 0) then
        showDescription(LOCALIZE("S26_JUG"))
        else
        showDescription(LOCALIZE("S26_TABLE"))
        end

	if(sceneState.cup > 0 and sceneState.cup < 3)then
		scene_members["cupPlaced"..sceneState.cup]:setVisible(true)
	end
end


function scene_selectors.hogPressed(sender)
	game.startSubScene("hog_16", scene_members.minigames, scene_members.sceneMenu)
    sceneHOGNum = 26;
    game.initCommonHog(scene26)
end

local function brokePars()
	scene_members.barsBroken:runAction(CCSequence:createWithTwoActions(CCFadeTo:create(1.4,255), CCCallFunc:create(function()
																														sceneState.barsBroken = 1
																														updateScreen()
																														if(sceneState.cup >= 2 ) then
																															game.removeItem("jugpouring")
																														end
																														game.closeSubScene()
																													   end
																													   )))
end

local function pourBars()
	local animations = CCArray:create()
	game.restartParticles(scene_members.sparks)
	scene_members.sparks:setVisible(true)
	game.restartParticles(scene_members.smoke)
	scene_members.smoke:setVisible(true)
    pourEffectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0136_pourwaterdirt.mp3"))
	animations:addObject(CCMoveTo:create(0.7,ccp(536,544)))
	animations:addObject(CCCallFunc:create(brokePars))
	animations:addObject(CCMoveTo:create(0.9,ccp(554,509)))
	animations:addObject(CCFadeTo:create(0.3,0))
    shockEffectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0128_shocksequence.mp3"))
	scene_members.jugPouring:runAction(CCFadeTo:create(0.2,255))
    scene_members.jugPouring:runAction(CCSequence:create(animations))
end

local function setCup()
	print("state",sceneState.cup)
	if(sceneState.cup == 0)then
		print("stting")
        showDescription(LOCALIZE("S26_SETCUP"))
        effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0137_placeglass.mp3"))
		scene_members.cupPlaced1:setOpacity(0)
		scene_members.cupPlaced1:setVisible(true)
		scene_members.cupPlaced1:runAction(CCFadeTo:create(0.2,255))
		sceneState.cup = 1
		game.removeItem("cupempty")
	end
	
end
local function fillWater()
	if(sceneState.cup == 1)then
		print("filling")
		scene_members.jug:setVisible(true)
		scene_members.jug:runAction(CCFadeIn:create(0.3))
        showDescription(LOCALIZE("S26_FILLWATER"))
		--scene_members.jug:runAction(CCMoveTo:create(0.7,ccp(545,555)))
		effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0109_fillglasswater.mp3"))
		scene_members.jug:runAction(CCSequence:createWithTwoActions(CCMoveTo:create(0.7,ccp(545,555)),CCFadeOut:create(0.3)))
		scene_members.cupPlaced2:setOpacity(0)
		scene_members.cupPlaced2:setVisible(true)
		scene_members.cupPlaced1:runAction(CCFadeTo:create(0.1,0))
		scene_members.cupPlaced2:runAction(CCFadeTo:create(0.3,255))
		sceneState.cup = 2
		if(sceneState.barsBroken == 1)then
			game.removeItem("jugpouring")
		end
	end
end

local function setPil()
	if(sceneState.cup == 2)then
		print("filling")
        showDescription(LOCALIZE("S26_SETPILS"))
		local animations = CCArray:create()
		animations:addObject(CCMoveTo:create(0.7,ccp(683,500)))
		animations:addObject(CCMoveTo:create(0.7,ccp(734,505)))
		animations:addObject(CCMoveTo:create(0.7,ccp(683,500)))
		animations:addObject(CCFadeOut:create(0.3))
		scene_members.med:runAction(CCFadeIn:create(0.2))
		scene_members.med:setVisible(true)
        effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0142_medicinepour.mp3"))
		scene_members.med:runAction(CCSequence:create(animations))
		scene_members.cupPlaced2:runAction(CCSequence:createWithTwoActions(CCFadeTo:create(0.5,0), CCCallFunc:create(function()
																													 scene_members.cupPlaced3:runAction(CCFadeIn:create(0.5))
																													 scene_members.cupPlaced3:setVisible(true)
																													 sceneState.cup = 3
																													 game.removeItem("medicine")
																													 end
																													 )))
	end
end

local function brokeGlass()
	scene_members.glassFull:runAction(CCFadeTo:create(0.3,0))
    effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0075_glassburst.mp3"))
	scene_members.glassBroken:runAction(CCSequence:createWithTwoActions(CCFadeIn:create(0.3), CCCallFunc:create(function()
																												   sceneState.winBroken = 1
																												   scene_members.pepper:setTouchEnabled(sceneState.winBroken == 1)
																												   game.removeItem("stick")
																												   end
																												   )))
	scene_members.glassBroken:setVisible(true)
end


function inventoryItemUsed(it, x, y, action, sender)
	print("item used: ", it, x, y, action, sender)
	
	if(it == "jugpouring" ) then
		core.CCLOG("11")
		game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.barsBroken,pourBars,action)
	end
	if(it == "jugpouring") then
		core.CCLOG("22")
		game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.cupPlaced1,fillWater,action)
	end
	if(it == "cupempty") then
		core.CCLOG("33")
		game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.cupPlaced1,setCup,action)
	end
	if(it == "medicine") then
		core.CCLOG("44")
		game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.cupPlaced1,setPil,action)
	end
	if(it == "stick") then
		core.CCLOG("55")		
		game.enablesItemfromInventoryToItemOnScene(x,y,scene_members.glassFull,brokeGlass,action)
	end

end

function updateScreen()
	--batarries
	scene_members.drawerGhost:setVisible(sceneState.batery1 == 0 and sceneState.batery2 == 0)
	--pils
	scene_members.cupBoardGhost:setVisible(sceneState.pepper == 0 and sceneState.medicine == 0)
	scene_members.glassBroke:setVisible(sceneState.winBroken == 1)
	scene_members.glassFul:setVisible(sceneState.winBroken == 0)
	--table
	scene_members.tableGhost:setVisible(sceneState.cupPlaced3 == 0)
	scene_members.jugAndCupButton:setVisible(sceneState.cupPlaced3 == 0)
	scene_members.cupWater:setVisible(sceneState.cup > 0 and sceneState.cupPlaced3 == 0)
	if(game.hasItem("clothes"))then
		sceneState.canEscape = sceneState.canEscape + 1
        effectID = SimpleAudioEngine:sharedEngine():playEffect(CCFileUtils:sharedFileUtils():fullPathFromRelativePath("music/sfx/s_0138_seeds.mp3"))
        showDescription(LOCALIZE("S26_CLOTHES"),2)
        game.removeItem("clothes")
	end
	if(game.hasItem("cupPlaced3"))then
		sceneState.canEscape = sceneState.canEscape + 1
        showDescription(LOCALIZE("S26_FILLGOOD"),2)
		game.removeItem("cupPlaced3")
	end
	--scene_members.exitSquareButton:setVisible(sceneState.canEscape == 2 and sceneState.barsBroken == 1)
	
end

function event()
	updateScreen()

	if(sceneState.medicine == 1) then
		scene_members.medPils:setVisible(false)
	end

	if(sceneState.pepper == 1) then
		scene_members.pepCan:removeFromParentAndCleanup(true)
	end

	if(sceneState.jugpouring == 1) then
		scene_members.winJug:setVisible(false)
	end



	if(sceneState.coin1 == 1) then
		scene_members.coin1:removeFromParentAndCleanup(true)
	end
	if(sceneState.clothes == 1) then
		scene_members.clothes:removeFromParentAndCleanup(true)
	end
	
	if(sceneState.cupempty == 1) then
		scene_members.cupempty:removeFromParentAndCleanup(true)
	end

	--cupboard
	scene_members.glassFul:setVisible(sceneState.winBroken == 0)
	scene_members.glassBroke:setVisible(sceneState.winBroken == 1)

	--bars and window
	scene_members.redLight:setVisible(sceneState.barsBroken == 0)
	scene_members.greenLight:setVisible(sceneState.barsBroken == 1)
	scene_members.ironBars:setVisible(sceneState.barsBroken == 0)
	scene_members.boxGhost:setVisible(sceneState.barsBroken == 0)
	scene_members.barsButton:setVisible(sceneState.barsBroken == 0)
	scene_members.closetWindow:setVisible(sceneState.barsBroken == 0)
	if(sceneState.barsBroken == 1) then
		scene_members.openedWindow:setOpacity(255)
	end
    scene_members.exit:setVisible(false)
	
end